/*_____________________________   fsgJTAPI.c   _______________________________*/
/*                                                                            */
/* NOTE NOTE NOTE NOTE NOTE NOTE NOTE NOTE NOTE NOTE NOTE NOTE NOTE NOTE NOTE */
/*                                                                            */
/* ---> NI == NOT IMPLEMENTED shall mean that this thin thread instantiation  */
/*                      does implementation a particular API, function or     */
/*                      capability.  Final / Complete instantiation may       */
/*                      support all APIs, functions and capabilities.         */
/*                                                                            */
/*       1         2         3         4         5         6         7        */
/*3456789012345678901234567890123456789012345678901234567890123456789012345678*/
/**************************************|***************************************/
/*                                                                            */
/*   Copyright (c) 2007  Glen Petrie         All rights reserved.             */
/*                                                                            */
/*   Permission is hereby granted, free of charge, to any person obtaining    */
/*   a copy of this software and associated documentation files (the          */
/*   "Software"), to deal in the Software without restriction, including      */
/*   without limitation the rights to use, copy, modify, merge, publish,      */
/*   distribute, and/or sell copies of the Software, and to permit persons    */
/*   to whom the Software is furnished to do so, subject to the following     */
/*   conditions:                                                              */
/*                                                                            */
/*   The rights to use, copy, modify, merge, publish, distribute, and/or      */
/*   sell copies of this Software or any material modification thereof        */
/*   shall not be further restricted by any means, including, but not         */
/*   limited to, the GNU General Public License.                              */
/*                                                                            */
/*   The above copyright notice and this permission notice shall be           */
/*   included in all copies or substantial portions of the Software.          */
/*                                                                            */
/*   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,          */
/*   EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF       */
/*   MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.   */
/*   IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY     */
/*   CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,     */
/*   TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE        */
/*   SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.                   */
/*                                                                            */
/*                                                                            */
/**************************************|***************************************/
/*                                                                            */
/*                         Open-Printing Embedded Print                       */
/*                                                                            */
/*                      Core OPEP Job Ticket (source) File                    */
/*                                                                            */
/* Library Management                                                         */
/* -------------------------------------------------------------------------- */
/*     API-150500  fsgjt_return_code_t  fsgjtOpenJTAPI(...)                   */
/*                                                                            */
/*     API-150501  fsgjt_return_code_t  fsgjtFlushJTAPI(...)                  */
/*                                                                            */
/*     API-150502  fsgjt_return_code_t  fsgjtCloseJTAPI(...)                  */
/*                                                                            */
/* Create Object 
/* -------------------------------------------------------------------------- */
/*     API-150550  fsgjt_return_code_t  fsgjtNewJobTicketInfo(...)            */
/*                                                                            */
/* NI  API-150551  fsgjt_status_t       fsgjtNewJobTicketInfoFromURI(...)     */
/*                                                                            */
/* NI  API-150552  fsgjt_status_t       fsgjtNewJobTicketInfoFromBuffer(...)  */
/*                                                                            */
/* NI  API-150553  fsgjt_return_code_t  fsgjtNewJobTicketInfoFromJob(...)     */
/*                                                                            */
/*     API-150554  fsgjt_return_code_t  fsgjtNewContactInfo(...)              */
/*                                                                            */
/*     API-150555  fsgjt_return_code_t  fsgjtNewDestination(...)              */
/*                                                                            */
/*     API-150556  fsgjt_return_code_t  fsgjtNewDocument(...)                 */
/*                                                                            */
/* NI  API-150557  fsgjt_return_code_t  fsgjtNewDocumentFromURI(...)          */
/*                                                                            */
/*     API-150558  fsgjt_return_code_t  fsgjtNewFolding(...)                  */
/*                                                                            */
/*     API-150559  fsgjt_return_code_t  fsgjtNewForcePage(...)                */
/*                                                                            */
/*     API-150560  fsgjt_return_code_t  fsgjtNewHoleMaking(...)               */
/*                                                                            */
/*     API-150561  fsgjt_return_code_t  fsgjtNewInsertSheet(...)              */
/*                                                                            */
/*     API-150562  fsgjt_return_code_t  fsgjtNewJob(...)                      */
/*                                                                            */
/* NI  API-150563  fsgjt_return_code_t  fsgjtNewJobFromDocument(...)          */
/*                                                                            */
/*     API-150564  fsgjt_return_code_t  fsgjtNewMedia(...)                    */
/*                                                                            */
/*     API-150565  fsgjt_return_code_t  fsgjtNewPageRange(...)                */
/*                                                                            */
/*     API-150566  fsgjt_return_code_t  fsgjtNewSeparatorSheet(...)           */
/*                                                                            */
/*     API-150567  fsgjt_return_code_t  fsgjtNewStitching(...)                */
/*                                                                            */
/*     API-150568  fsgjt_return_code_t  fsgjtNewSubscription(...)             */
/*                                                                            */
/* Destroy Objects                                                            */
/* -------------------------------------------------------------------------- */
/*     API-150600  fsgjt_return_code_t  fsgjtDestroy(...)                     */
/*                                                                            */
/* Write Job-Ticket                                                           */
/* -------------------------------------------------------------------------- */
/*     API-150650  fsgjt_return_code_t  fsgjtWriteJobTicketToBuffer(...)      */
/*                                                                            */
/*     API-150651  fsgjt_return_code_t  fsgjtWriteJobTicketToURI(...)         */
/*                                                                            */
/* Create  Attributes / Values                                                */
/* -------------------------------------------------------------------------- */
/*     API-150700  fsgjt_return_code_t  fsgjtNewAttribute(...)                */
/*                                                                            */
/* Set     Attributes / Values                                                */
/* -------------------------------------------------------------------------- */
/*     API-150750  fsgjt_return_code_t  fsgjtSet(...)                         */
/*                                                                            */
/*     API-150751  fsgjt_return_code_t  fsgjtSetIntegerAttribute(...)         */
/*                                                                            */
/*     API-150752  fsgjt_return_code_t  fsgjtSetObjectAttribute(...)          */
/*                                                                            */
/*     API-150753  fsgjt_return_code_t  fsgjtSetObjectAttributeList(...)      */
/*                                                                            */
/*     API-150754  fsgjt_return_code_t  fsgjtSetTextAttribute(...)            */
/*                                                                            */
/*     API-150755  fsgjt_return_code_t  fsgjtSetTextAttributeList(...)        */
/*                                                                            */
/*     API-150756  fsgjt_return_code_t  fsgjtReplaceValue(...)                */
/*                                                                            */
/*     API-150757  fsgjt_return_code_t  fsgjtAddValue(...)                    */
/*                                                                            */
/* Get     Attributes / Values                                                */
/* -------------------------------------------------------------------------- */
/*     API-150800  fsgjt_return_code_t  fsgjtGet(...)                         */
/*                                                                            */
/*     API-150801  fsgjt_return_code_t  fsgjtGetName(...)                     */
/*                                                                            */
/*     API-150802  fsgjt_return_code_t  fsgjtGetNextValue(...)                */
/*                                                                            */
/*     API-150803  fsgjt_return_code_t  fsgjtGetNumValues(...)                */
/*                                                                            */
/*     API-150804  fsgjt_return_code_t  fsgjtGetValueType(...)                */
/*                                                                            */
/*     API-150805  fsgjt_return_code_t  fsgjtResetToFirstValue(...)           */
/*                                                                            */
/* Destroy Attributes / Values                                                */
/* -------------------------------------------------------------------------- */
/*     API-150850  fsgjt_return_code_t  fsgjtDestroyAttribute(...)            */
/*                                                                            */
/**************************************|***************************************/
/*                                                                            */
/*  Contributors:                                                             */
/*        Glen W. Petrie / The World of Graphics                              */
/*                                                                            */
/**************************************|***************************************/
/*                                                                            */
/* Revision Log                                                               */
/*      Date             Who                                                  */
/*      2007.07.30       Glen W. Petrie                                       */
/*    # Original code                                                         */
/*                                                                            */
/**************************************|***************************************/
/*                                                                            */
/* Special Software and/or Usage Information                                  */
/*                                                                            */
/* # All exposed API's in this file utilize the OPEP global link-list error   */
/*   structure with the global variable name of op_error.                     */
/*                                                                            */
/**************************************|***************************************/
 
/*--------------------------------  Includes   -------------------------------*/
/**************************************|***************************************/
#include "opGeneric.h"
#include "opJobStructs.h"

#include "opJTAPI.h"

#include "fsgjt.h"
#include "fsgjt_attribute.h"
#include "fsgjt_contact_info.h"
#include "fsgjt_destination.h"
#include "fsgjt_document.h"
#include "fsgjt_enums.h"
#include "fsgjt_folding.h"
#include "fsgjt_force_page.h"
#include "fsgjt_hole_making.h"
#include "fsgjt_insert_sheet.h"
#include "fsgjt_job.h"
#include "fsgjt_job_ticket_info.h"
#include "fsgjt_media.h"
#include "fsgjt_page_range.h"
#include "fsgjt_separator_sheet.h"
#include "fsgjt_stitching.h"
#include "fsgjt_subscription.h"

/*-------------------------------  Definitions   -----------------------------*/
/**************************************|***************************************/

    /*** FSGJT Additions or corrections                                       */
    /*** -------------------------------------------------------------------- */
#define FSGJT_VT_JOB_TICKET_OBJECT                  "JOB_TICKET_OBJECT"
// error #define FSGJT_VT_SEPARATOR_SHEET_ENUM        "SEPARATOR_SHEET_ENUM"
#define FSGJT_VT_SEPARATOR_SHEET_TYPE_ENUM        "SEPARATOR_SHEET_TYPE_ENUM"



    /*** FSGJT Struct'ed Error Macro's                                        */
    /*** -------------------------------------------------------------------- */
    /*** Structure that contains the status and additional information if     */
    /*** a parser error occurred.                                             */
    /*** -------------------------------------------------------------------- */
    /*** typedef struct fsgjt_status_s {                                      */
    /***    fsgjt_return_code_t returnCode;  /* Return code                   */
    /***    fsgjt_int32_t lineNumber;        /* Line number where error       */ 
    /***                                     /* occurred or 0 if unavailable. */
    /***    fsgjt_int32_t columnNumber;      /* Column number where error     */
    /***                                     /* occurred or 0 if unavailable. */
    /*** } fsgjt_status_t;                                                    */ 
    /*** -------------------------------------------------------------------- */
#define FSG_SET_ERR_STATUS(x)   status.returnCode = (x); OP_SET_ERR((x));
#define FSG_SET_ERR(x)          status = (x);            OP_SET_ERR((x));


/*---------------------------  Macro Definitions  ----------------------------*/
/**************************************|***************************************/
#define CHECK_JOB_TKT(j,a)  if (FindAjobTktId((j)) == NULL) {               \
                                OP_SET_ERR(OPJT_INVALID_JOB_TICKET);        \
                                opDebugFlowOut(a); return; }

#define CREATE_NEW_OBJECT_WITH_DATA(objN,objT,objD,attN,attT,attD)          \
    while (status == FSGJT_OK) {                                            \
        thisElement = CreateJtElement();                                    \
        if (thisElement == NULL) { status = FSGJT_INTERNAL_ERROR; break; }  \
        thisElement->data = objD;                                           \
        thisElement->name = (fsgjt_text_t)malloc(strlen(objN));             \
        if (thisElement->name == NULL)                                      \
            { status = FSGJT_INTERNAL_ERROR; break; }                       \
        strcpy(thisElement->name, objN);                                   \
        thisElement->type = (fsgjt_text_t)malloc(strlen(objT));             \
        if (thisElement->type == NULL) {                                    \
            DestroyJtElement(thisElement);                                  \
            status = FSGJT_INTERNAL_ERROR; break; }                         \
        strcpy(thisElement->type, objT);                                   \
        thisElement->parent = NULL; /* object has no parent */              \
        status = fsgjtNewAttribute((void*)&thisAttribute,                   \
                                   attN, attT, attD);                       \
        if (status != FSGJT_OK) { DestroyJtElement(thisElement); break; }   \
        thisAttribute->parent = (void*)thisElement;  }                      

/*---------------------------  Struct Definitions  ---------------------------*/
/**************************************|***************************************/

/*----------------------  Application Global Variables   ---------------------*/
/**************************************|***************************************/

/*-------------------------  Local Global Variables   ------------------------*/
/**************************************|***************************************/

    /*** Job Ticket Element Holder                                            */
    /*** -------------------------------------------------------------------- */
typedef struct {
    void*           data;               /* Data for this element              */
    fsgjt_text_t    name;
    fsgjt_text_t    type;
    void*           parent;             /* Parent Object element belongs to   */
} fsgjt_element_t;

fsgjt_element_t** jtElements;            /* List of Job Ticket Elements        */
fsgjt_int32_t   numJtElements;          /* Number of job ticket elements      */

/*----------------------------  Local Functions   ----------------------------*/
/**************************************|***************************************/
static fsgjt_element_t* CreateJtElement(void);
static void             DestroyJtElement(fsgjt_element_t*);

/*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%|%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%*/
/*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%|%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%*/
/*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%|%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%*/
/*   Library Library Library Library Library Library Library Library Library  */
/*     Management Management Management Management Management Management      */
/* -------------------------------------------------------------------------- */
/* -------------------------------------------------------------------------- */
/*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%|%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%*/
/*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%|%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%*/
/*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%|%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%*/

/**************************************|***************************************/
/*                                                              API-150500    */
/* fsgjtOpenJTAPI - Initializes the JTAPI library and may return context      */
/*                  structure used by the specific JTAPI library instance     */
/*                  Note: must be called before calling any other JTAPI       */
/*                  library methods.                                          */
/*                                                                            */
/* param (output)   void**              context                               */
/*                  - Pointer to opaque JTAPI interface context structure     */
/*                                                                            */
/* return           fsgjt_return_code_t     (enum)                            */
/*                                                                            */
/**************************************|***************************************/
/*                                                                            */
/* Revision Log                                                               */
/*      Date             Who                                                  */
/*      2007.08.22       Glen W. Petrie                                       */
/*    # Original code                                                         */
/*                                                                            */
/**************************************|***************************************/
fsgjt_return_code_t fsgjtOpenJTAPI(     /* OP_INT32  */

        void**  context                 /* void**    */

) {
/*** Declaration of Local Routine Variables                                   */
fsgjt_return_code_t  status;

/*** API Identifier Information for this Routine                              */
	OP_API_REG(150500, "fsgjtOpenJTAPI");

/*** Debug Flow Information for this Routine                                  */
    opDebugFlowIn("fsgjtOpenJTAPI");

/*** Initialization of Local Routine Variables                                */
    status = FSGJT_OK;

/*** Initialize Application global variables                                  */
    numJtElements = 0;

/*** Return to Caller                                                         */
    FSG_SET_ERR(status);
    opDebugFlowOut("fsgjtOpenJTAPI");
    return(status);

}

/**************************************|***************************************/
/*                                                              API-150501    */
/* fsgjtFlushJTAPI - Releases all objects and dynamic memory and closes any   */
/*                   I/O channels that are associated with this specific      */
/*                   JTAPI library instance.                                  */
/*                                                                            */
/* param (input)    void*               context                               */
/*                  - Opaque JTAPI interface context structure                */
/*                                                                            */
/* return           fsgjt_return_code_t     (enum)                            */
/*                                                                            */
/**************************************|***************************************/
/*                                                                            */
/* Revision Log                                                               */
/*      Date             Who                                                  */
/*      2007.08.22       Glen W. Petrie                                       */
/*    # Original code                                                         */
/*                                                                            */
/**************************************|***************************************/
fsgjt_return_code_t fsgjtFlushJTAPI(    /* OP_INT32  */

        void*   context                 /* void*     */

) {
/*** Declaration of Local Routine Variables                                   */
fsgjt_return_code_t  status;

/*** API Identifier Information for this Routine                              */
	OP_API_REG(150501, "fsgjtFlushJTAPI");

/*** Debug Flow Information for this Routine                                  */
    opDebugFlowIn("fsgjtFlushJTAPI");

/*** Initialization of Local Routine Variables                                */
    status = FSGJT_OK;

/*** Clean up                                                                 */

/*** Return to Caller                                                         */
    FSG_SET_ERR(status);
    opDebugFlowOut("fsgjtFlushJTAPI");
    return(status);

}

/**************************************|***************************************/
/*                                                              API-150502    */
/* fsgjtCloseJTAPI - Releases this specific JTAPI library instance            */
/*                   (and internally calls fsgjtFlushJTAPI).                  */
/*                                                                            */
/* param (input)    void*               context                               */
/*                  - Opaque JTAPI interface context structure                */
/*                                                                            */
/* return           fsgjt_return_code_t     (enum)                            */
/*                                                                            */
/**************************************|***************************************/
/*                                                                            */
/* Revision Log                                                               */
/*      Date             Who                                                  */
/*      2007.08.22       Glen W. Petrie                                       */
/*    # Original code                                                         */
/*                                                                            */
/**************************************|***************************************/
fsgjt_return_code_t fsgjtCloseJTAPI(    /* OP_INT32  */

        void*   context                 /* void*     */

) {
/*** Declaration of Local Routine Variables                                   */
fsgjt_return_code_t  status;

/*** API Identifier Information for this Routine                              */
	OP_API_REG(150502, "fsgjtCloseJTAPI");

/*** Debug Flow Information for this Routine                                  */
    opDebugFlowIn("fsgjtCloseJTAPI");

/*** Initialization of Local Routine Variables                                */
    status = FSGJT_OK;

/*** Clean up                                                                 */

/*** Return to Caller                                                         */
    FSG_SET_ERR(status);
    opDebugFlowOut("fsgjtCloseJTAPI");
    return(status);

}

/*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%|%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%*/
/*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%|%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%*/
/*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%|%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%*/
/*  Create  Create  Create  Create  Create  Create  Create  Create  Create    */
/*  Objects Objects Objects Objects Objects Objects Objects Objects Objects   */
/* -------------------------------------------------------------------------- */
/* Object Hierarchy                                                           */
/* -------------------------------------------------------------------------- */
/*                                                                            */
/* OP_JOB_TICKET_INFO_OBJECT                                                  */
/*    OP_JOB_OBJECT                                                           */
/*                                                                            */
/* OP_JOB_OBJECT                                                              */
/*    OP_CONTACT_INFO_OBJECT                                                  */
/*    OP_DESTINATION_OBJECT                                                   */
/*    OP_DOCUMENT_OBJECT                                                      */
/*    OP_FOLDING_OBJECT                                                       */
/*    OP_FORCE_PAGE_OBJECT                                                    */
/*    OP_HOLE_MAKING_OBJECT                                                   */
/*    OP_INCLUDE_PAGES_OBJECT     --> OP_PAGE_RANGE_OBJECT                    */
/*    OP_INSERT_SHEET_OBJECT                                                  */
/*    OP_JOB_MEDIA_OBJECT         --> OP_MEDIA_OBJECT                         */
/*    OP_OUTPUT_PAGES_OBJECT      --> OP_PAGE_RANGE_OBJECT                    */
/*    OP_SEPARATOR_SHEET_OBJECT                                               */
/*    OP_STITCHING_OBJECT                                                     */
/*    OP_SUBSCRIPTION_OBJECT                                                  */
/*                                                                            */
/* OP_DOCUMENT_OBJECT                                                         */
/*    OP_DOC_PAGE_RANGE_OBJECT    --> OP_PAGE_RANGE_OBJECT                    */
/*    OP_DOC_FORCE_PAGE_OBJECT    --> OP_PAGE_RANGE_OBJECT                    */
/*    OP_DOC_INSERT_SHEET_OBJECT  --> OP_PAGE_RANGE_OBJECT                    */
/*                                                                            */
/* OP_PAGE_RANGE_OBJECT                                                       */
/*    <---->                                                                  */
/*                                                                            */
/* OP_DESTINATION_OBJECT                                                      */
/*    <---->                                                                  */
/*                                                                            */
/* OP_CONTACT_INFO_OBJECT                                                     */
/*    <---->                                                                  */
/*                                                                            */
/* OP_SUBSCRIPTION_OBJECT                                                     */
/*    <---->                                                                  */
/*                                                                            */
/* OP_SEPARATOR_SHEET_OBJECT                                                  */
/*    OP_SEP_SHEET_MEDIA_OBJECT   --> OP_MEDIA_OBJECT                         */
/*                                                                            */
/* OP_MEDIA_OBJECT                                                            */
/*    <---->                                                                  */
/*                                                                            */
/* OP_FORCE_PAGE_OBJECT                                                       */
/*    <---->                                                                  */
/*                                                                            */
/* OP_INSERT_SHEET_OBJECT                                                     */
/*    OP_INSERT_SHEET_MEDIA_OBJECT      --> OP_MEDIA_OBJECT                   */
/*    OP_INSERT_SHEET_PAGE_RANGE_OBJECT --> OP_PAGE_RANGE_OBJECT              */
/*                                                                            */
/* OP_HOLE_MAKING_OBJECT                                                      */
/*    <---->                                                                  */
/*                                                                            */
/* OP_FOLDING_OBJECT                                                          */
/*    <---->                                                                  */
/*                                                                            */
/* OP_STITCHING_OBJECT                                                        */
/*    <---->                                                                  */
/*                                                                            */
/* -------------------------------------------------------------------------- */
/*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%|%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%*/
/*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%|%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%*/
/*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%|%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%*/

/**************************************|***************************************/
/*                                                              API-150550    */
/* fsgjtNewJobTicketInfo - Creates a JobTicketInfo object.                    */
/*                       - Used when a new JobTicketInfo is being created     */
/*                         without a Job object and not from an external job  */
/*                         ticket.                                            */
/*                                                                            */
/* param (output)   fsgjt_object_t*     jobTicketInfo                         */
/*                  - Pointer to the new JobTicketInfo to create              */
/*                                                                            */
/* param (input)    fsgjt_job_ticket_type_version_t typeAndVersion            */
/*                  - Type and version of this Job Ticket                     */
/*                          (use JobTicketTypeVersionEnum)                    */
/*                                                                            */
/* return           fsgjt_return_code_t     (enum)                            */
/*                                                                            */
/**************************************|***************************************/
/*                                                                            */
/* Revision Log                                                               */
/*      Date             Who                                                  */
/*      2007.08.22       Glen W. Petrie                                       */
/*    # Original code                                                         */
/*                                                                            */
/**************************************|***************************************/
fsgjt_return_code_t fsgjtNewJobTicketInfo(              /* OP_INT32  */

        fsgjt_object_t*                 jobTicketInfo,  /* void**    */
        fsgjt_job_ticket_type_version_t typeAndVersion  /* enum      */

) {
/*** Declaration of Local Routine Variables                                   */
fsgjt_return_code_t  status;
fsgjt_element_t*     thisElement;
fsgjt_element_t*     thisAttribute;

/*** API Identifier Information for this Routine                              */
	OP_API_REG(150550, "fsgjtNewJobTicketInfo");

/*** Debug Flow Information for this Routine                                  */
    opDebugFlowIn("fsgjtNewJobTicketInfo");

/*** Initialization of Local Routine Variables                                */
    status = FSGJT_OK;

/*** Create a element record                                                  */
    while (status == FSGJT_OK) {
        thisElement = CreateJtElement();
        if (thisElement == NULL) { status = FSGJT_INTERNAL_ERROR; break; }

        thisElement->data = NULL;

        thisElement->name = 
                (fsgjt_text_t)malloc(strlen(FSGJT_JOB_TICKET_INFO_OBJECT));
        if (thisElement->name == NULL) { 
            status = FSGJT_INTERNAL_ERROR; 
            break; 
        }
        strcpy(thisElement->name, FSGJT_JOB_TICKET_INFO_OBJECT);

        thisElement->type = 
                    (fsgjt_text_t)malloc(strlen(FSGJT_VT_JOB_TICKET_OBJECT));
        if (thisElement->type == NULL) { 
            DestroyJtElement(thisElement); 
            status = FSGJT_INTERNAL_ERROR; 
            break; 
        }
        strcpy(thisElement->type, FSGJT_VT_JOB_TICKET_OBJECT);

        thisElement->parent = NULL; /* Job Ticket has no parent               */
    
    /*** Set incoming Job Ticket type and version                             */
        status = fsgjtNewAttribute((void*)&thisAttribute,
                                   FSGJT_JT_TYPE_AND_VERSION,
                                   FSGJT_VT_JOB_TICKET_TYPE_VERSION_ENUM,
                                   &typeAndVersion);
        if (status != FSGJT_OK) { DestroyJtElement(thisElement); break; }
        thisAttribute->parent = (void*)thisElement;
    }

/*** Return to Caller                                                         */
    FSG_SET_ERR(status);
    opDebugFlowOut("fsgjtNewJobTicketInfo");
    return(status);

}

/**************************************|***************************************/
/* NOT IMPLEMENTED in this thin thread instantiation            API-150551    */
/* fsgjtNewJobTicketInfoFromURI - Creates a JobTicketInfo object from the     */
/*                                job ticket file at the provided URI. Other  */
/*                                JTAPI objects are also created based on the */
/*                                information in the job ticket file.         */
/*                                                                            */
/* param (output)   fsgjt_object_t*     jobTicketInfo                         */
/*                  - Pointer to the JobTicketInfo to create                  */
/*                                                                            */
/* param (input)    fsgjt_uri_t         uri                                   */
/*                  - URI where job ticket file resides                       */
/*                                                                            */
/* param (input)    fsgjt_job_ticket_type_version_t typeAndVersion            */
/*                  - Type and version of this Job Ticket                     */
/*                          (use JobTicketTypeVersionEnum)                    */
/*                                                                            */
/* return           fsgjt_status_t                                            */
/*                                                                            */
/**************************************|***************************************/
/*                                                                            */
/* Revision Log                                                               */
/*      Date             Who                                                  */
/*      2007.08.22       Glen W. Petrie                                       */
/*    # Original code                                                         */
/*                                                                            */
/**************************************|***************************************/
/* NOT IMPLEMENTED in this thin thread instantiation            API-150551    */
/* NOT IMPLEMENTED in this thin thread instantiation            API-150551    */
/* NOT IMPLEMENTED in this thin thread instantiation            API-150551    */
/* NOT IMPLEMENTED in this thin thread instantiation            API-150551    */
/* NOT IMPLEMENTED in this thin thread instantiation            API-150551    */
fsgjt_status_t fsgjtNewJobTicketInfoFromURI( 

        fsgjt_object_t*                 jobTicketInfo,  /* void**    */
        fsgjt_uri_t                     uri,            /* char*     */
        fsgjt_job_ticket_type_version_t typeAndVersion  /* enum      */

) {
/*** Declaration of Local Routine Variables                                   */
fsgjt_status_t  status;

/*** API Identifier Information for this Routine                              */
	OP_API_REG(150551, "fsgjtNewJobTicketInfoFromURI");

/*** Debug Flow Information for this Routine                                  */
    opDebugFlowIn("fsgjtNewJobTicketInfoFromURI");

/*** Initialization of Local Routine Variables                                */

/*TT New Job Ticket Info From URI is not supported at this time               */
    FSG_SET_ERR_STATUS(FSGJT_NOT_SUPPORTED);
    opDebugFlowOut("fsgjtNewJobTicketInfoFromURI");
    return(status);

/*** Return to Caller                                                         */
    FSG_SET_ERR_STATUS(FSGJT_OK);
    opDebugFlowOut("fsgjtNewJobTicketInfoFromURI");
    return(status);

}

/**************************************|***************************************/
/* NOT IMPLEMENTED in this thin thread instantiation            API-150552    */
/* fsgjtNewJobTicketInfoFromBuffer - Creates a JobTicketInfo object from the  */
/*                                   provided buffer that contains a job      */
/*                                   ticket. Other JTAPI objects are also     */
/*                                   created based on the information in the  */
/*                                   job ticket buffer.                       */
/*                                                                            */
/* param (output)   fsgjt_object_t*     jobTicketInfo                         */
/*                  - Pointer to the JobTicketInfo to create                  */
/*                                                                            */
/* param (input)    fsgjt_text_t        buffer                                */
/*                  - Buffer that contains the job ticket                     */
/*                                                                            */
/* param (input)    fsgjt_int32_t       bufferSize                            */
/*                  - Size of the input buffer                                */
/*                                                                            */
/* param (input)    fsgjt_job_ticket_type_version_t typeAndVersion            */
/*                  - Type and version of this Job Ticket                     */
/*                          (use JobTicketTypeVersionEnum)                    */
/*                                                                            */
/* return           fsgjt_status_t                                            */
/*                                                                            */
/**************************************|***************************************/
/*                                                                            */
/* Revision Log                                                               */
/*      Date             Who                                                  */
/*      2007.08.22       Glen W. Petrie                                       */
/*    # Original code                                                         */
/*                                                                            */
/**************************************|***************************************/
/* NOT IMPLEMENTED in this thin thread instantiation            API-150552    */
/* NOT IMPLEMENTED in this thin thread instantiation            API-150552    */
/* NOT IMPLEMENTED in this thin thread instantiation            API-150552    */
/* NOT IMPLEMENTED in this thin thread instantiation            API-150552    */
/* NOT IMPLEMENTED in this thin thread instantiation            API-150552    */
fsgjt_status_t fsgjtNewJobTicketInfoFromBuffer(

        fsgjt_object_t*                 jobTicketInfo,  /* void**    */
        fsgjt_text_t                    buffer,         /* char*     */
        fsgjt_int32_t                   bufferSize,     /* OP_INT32  */
        fsgjt_job_ticket_type_version_t typeAndVersion  /* enum      */

) {
/*** Declaration of Local Routine Variables                                   */
fsgjt_status_t  status;

/*** API Identifier Information for this Routine                              */
	OP_API_REG(150552, "fsgjtNewJobTicketInfoFromBuffer");

/*** Debug Flow Information for this Routine                                  */
    opDebugFlowIn("fsgjtNewJobTicketInfoFromBuffer");

/*** Initialization of Local Routine Variables                                */

/*TT New Job Ticket Info From URI is not supported at this time               */
    FSG_SET_ERR_STATUS(FSGJT_NOT_SUPPORTED);
    opDebugFlowOut("fsgjtNewJobTicketInfoFromBuffer");
    return(status);

/*** Return to Caller                                                         */
    FSG_SET_ERR_STATUS(FSGJT_OK);
    opDebugFlowOut("fsgjtNewJobTicketInfoFromBuffer");
    return(status);

}

/**************************************|***************************************/
/* NOT IMPLEMENTED in this thin thread instantiation            API-150553    */
/* fsgjtNewJobTicketInfoFromJob - Creates a JobTicketInfo object using the    */
/*                                provided Job object. Used when a new job    */
/*                                ticket is being created. The Job object     */
/*                                must be created first.                      */
/*                                                                            */
/* param (output)   fsgjt_object_t*     jobTicketInfo                         */
/*                  - Pointer to the new JobTicketInfo to create.             */
/*                                                                            */
/* param (input)    fsgjt_object_t      job                                   */
/*                  - Job object that this JobTicketInfo is to contain        */
/*                                                                            */
/* param (input)    fsgjt_job_ticket_type_version_t typeAndVersion            */
/*                  - Type and version of this Job Ticket                     */
/*                          (use JobTicketTypeVersionEnum)                    */
/*                                                                            */
/* return           fsgjt_return_code_t     (enum)                            */
/*                                                                            */
/**************************************|***************************************/
/*                                                                            */
/* Revision Log                                                               */
/*      Date             Who                                                  */
/*      2007.08.22       Glen W. Petrie                                       */
/*    # Original code                                                         */
/*                                                                            */
/**************************************|***************************************/
/* NOT IMPLEMENTED in this thin thread instantiation            API-150553    */
/* NOT IMPLEMENTED in this thin thread instantiation            API-150553    */
/* NOT IMPLEMENTED in this thin thread instantiation            API-150553    */
/* NOT IMPLEMENTED in this thin thread instantiation            API-150553    */
/* NOT IMPLEMENTED in this thin thread instantiation            API-150553    */
fsgjt_return_code_t fsgjtNewJobTicketInfoFromJob(       /* OP_INT32  */

        fsgjt_object_t*                 jobTicketInfo,  /* void**    */
        fsgjt_object_t                  job,            /* void*     */
        fsgjt_job_ticket_type_version_t typeAndVersion  /* enum      */

) {
/*** Declaration of Local Routine Variables                                   */
fsgjt_return_code_t  status;

/*** API Identifier Information for this Routine                              */
	OP_API_REG(150553, "fsgjtNewJobTicketInfoFromJob");

/*** Debug Flow Information for this Routine                                  */
    opDebugFlowIn("fsgjtNewJobTicketInfoFromJob");

/*** Initialization of Local Routine Variables                                */
    status = FSGJT_OK;

/*TT New Job Ticket Info From URI is not supported at this time               */
    FSG_SET_ERR(FSGJT_NOT_SUPPORTED);
    opDebugFlowOut("fsgjtNewJobTicketInfoFromJob");
    return(status);

/*** Return to Caller                                                         */
    FSG_SET_ERR(status);
    opDebugFlowOut("fsgjtNewJobTicketInfoFromJob");
    return(status);

}

/**************************************|***************************************/
/*                                                              API-150554    */
/* fsgjtNewContactInfo - Creates a ContactInfo object having the provided     */
/*                       name.                                                */
/*                                                                            */
/* param (output)   fsgjt_object_t*     contactInfo                           */
/*                  - Pointer to the new ContactInfo object to create         */
/*                                                                            */
/* param (input)    fsgjt_text_t        name                                  */
/*                  - Name of person to contact or NULL if ContactInfo name   */
/*                    not specified                                           */
/*                                                                            */
/* return           fsgjt_return_code_t     (enum)                            */
/*                                                                            */
/**************************************|***************************************/
/*                                                                            */
/* Revision Log                                                               */
/*      Date             Who                                                  */
/*      2007.08.22       Glen W. Petrie                                       */
/*    # Original code                                                         */
/*                                                                            */
/**************************************|***************************************/
fsgjt_return_code_t fsgjtNewContactInfo(  /* OP_INT32  */

        fsgjt_object_t*     contactInfo,  /* void**    */
        fsgjt_text_t        name          /* char*     */

) {
/*** Declaration of Local Routine Variables                                   */
fsgjt_return_code_t  status;
fsgjt_element_t*     thisElement;
fsgjt_element_t*     thisAttribute;

/*** API Identifier Information for this Routine                              */
	OP_API_REG(150554, "fsgjtNewContactInfo");

/*** Debug Flow Information for this Routine                                  */
    opDebugFlowIn("fsgjtNewContactInfo");

/*** Initialization of Local Routine Variables                                */
    status = FSGJT_OK;

/*** Create a element record                                                  */
    while (status == FSGJT_OK) {
        thisElement = CreateJtElement();
        if (thisElement == NULL) { status = FSGJT_INTERNAL_ERROR; break; }

        thisElement->data = NULL;

        thisElement->name = 
                (fsgjt_text_t)malloc(strlen(FSGJT_CONTACT_INFO_OBJECT));
        if (thisElement->name == NULL) { 
            status = FSGJT_INTERNAL_ERROR; 
            break; 
        }
        strcpy(thisElement->name, FSGJT_CONTACT_INFO_OBJECT);

        thisElement->type = 
                    (fsgjt_text_t)malloc(strlen(FSGJT_VT_CONTACT_INFO_OBJECT));
        if (thisElement->type == NULL) { 
            DestroyJtElement(thisElement); 
            status = FSGJT_INTERNAL_ERROR; 
            break; 
        }
        strcpy(thisElement->type, FSGJT_VT_CONTACT_INFO_OBJECT);

        thisElement->parent = NULL; /* Job Ticket has no parent               */
    
    /*** Set incoming Job Ticket type and version                             */
        status = fsgjtNewAttribute((void*)&thisAttribute,
                                   FSGJT_CONTACT_INFO_NAME,
                                   FSGJT_VT_TEXT,
                                   name);
        if (status != FSGJT_OK) { DestroyJtElement(thisElement); break; }
        thisAttribute->parent = (void*)thisElement;
    }

/*** Return to Caller                                                         */
    FSG_SET_ERR(status);
    opDebugFlowOut("fsgjtNewContactInfo");
    return(status);

}

/**************************************|***************************************/
/*                                                              API-150555    */
/* fsgjtNewDestination - Creates a Destination object having the provided     */
/*                       target location URI.                                 */
/*                                                                            */
/* param (output)   fsgjt_object_t*     destination                           */
/*                  - Pointer to the new Destination object to create         */
/*                                                                            */
/* param (input)    fsgjt_uri_t         targetUri                             */
/*                  - URI that is the target location for this destination    */
/*                                                                            */
/* return           fsgjt_return_code_t     (enum)                            */
/*                                                                            */
/**************************************|***************************************/
/*                                                                            */
/* Revision Log                                                               */
/*      Date             Who                                                  */
/*      2007.08.22       Glen W. Petrie                                       */
/*    # Original code                                                         */
/*                                                                            */
/**************************************|***************************************/
fsgjt_return_code_t fsgjtNewDestination(  /* OP_INT32  */

        fsgjt_object_t*     destination,  /* void**    */
        fsgjt_uri_t         targetUri     /* char*     */

) {
/*** Declaration of Local Routine Variables                                   */
fsgjt_return_code_t  status;
fsgjt_element_t*     thisElement;
fsgjt_element_t*     thisAttribute;

/*** API Identifier Information for this Routine                              */
	OP_API_REG(150555, "fsgjtNewDestination");

/*** Debug Flow Information for this Routine                                  */
    opDebugFlowIn("fsgjtNewDestination");

/*** Initialization of Local Routine Variables                                */
    status = FSGJT_OK;

/*** Create a element record                                                  */
    while (status == FSGJT_OK) {
        thisElement = CreateJtElement();
        if (thisElement == NULL) { status = FSGJT_INTERNAL_ERROR; break; }

        thisElement->data = NULL;

        thisElement->name = 
                (fsgjt_text_t)malloc(strlen(FSGJT_DESTINATION_OBJECT));
        if (thisElement->name == NULL) { 
            status = FSGJT_INTERNAL_ERROR; 
            break; 
        }
        strcpy(thisElement->name, FSGJT_DESTINATION_OBJECT);

        thisElement->type = 
                    (fsgjt_text_t)malloc(strlen(FSGJT_VT_DESTINATION_OBJECT));
        if (thisElement->type == NULL) { 
            DestroyJtElement(thisElement); 
            status = FSGJT_INTERNAL_ERROR; 
            break; 
        }
        strcpy(thisElement->type, FSGJT_VT_DESTINATION_OBJECT);

        thisElement->parent = NULL; /* Job Ticket has no parent               */
    
    /*** Set incoming Job Ticket type and version                             */
        status = fsgjtNewAttribute((void*)&thisAttribute,
                                   FSGJT_DESTINATION_TARGET_URI,
                                   FSGJT_VT_URI,
                                   &targetUri);
        if (status != FSGJT_OK) { DestroyJtElement(thisElement); break; }
        thisAttribute->parent = (void*)thisElement;
    }

/*** Return to Caller                                                         */
    FSG_SET_ERR(status);
    opDebugFlowOut("fsgjtNewDestination");
    return(status);

}

/**************************************|***************************************/
/*                                                              API-150556    */
/* fsgjtNewDocument - Creates a Document object.                              */
/*                                                                            */
/* param (output)   fsgjt_object_t*     document                              */
/*                  - Pointer to the new document to be created               */
/*                                                                            */
/* return           fsgjt_return_code_t     (enum)                            */
/*                                                                            */
/**************************************|***************************************/
/*                                                                            */
/* Revision Log                                                               */
/*      Date             Who                                                  */
/*      2007.08.22       Glen W. Petrie                                       */
/*    # Original code                                                         */
/*                                                                            */
/**************************************|***************************************/
fsgjt_return_code_t fsgjtNewDocument(   /* OP_INT32  */

        fsgjt_object_t*     document    /* void**    */

) { 
/*** Declaration of Local Routine Variables                                   */
fsgjt_return_code_t  status;
fsgjt_element_t*     thisElement;

/*** API Identifier Information for this Routine                              */
	OP_API_REG(150556, "fsgjtNewDocument");

/*** Debug Flow Information for this Routine                                  */
    opDebugFlowIn("fsgjtNewDocument");

/*** Initialization of Local Routine Variables                                */
    status = FSGJT_OK;

    while (status == FSGJT_OK) {
        thisElement = CreateJtElement();
        if (thisElement == NULL) { status = FSGJT_INTERNAL_ERROR; break; }

        thisElement->data = NULL;

        thisElement->name = 
                (fsgjt_text_t)malloc(strlen(FSGJT_DOCUMENT_OBJECT));
        if (thisElement->name == NULL) { 
            status = FSGJT_INTERNAL_ERROR; 
            break; 
        }
        strcpy(thisElement->name, FSGJT_DOCUMENT_OBJECT);

        thisElement->type = 
                    (fsgjt_text_t)malloc(strlen(FSGJT_VT_DOCUMENT_OBJECT));
        if (thisElement->type == NULL) { 
            DestroyJtElement(thisElement); 
            status = FSGJT_INTERNAL_ERROR; 
            break; 
        }
        strcpy(thisElement->type, FSGJT_VT_DOCUMENT_OBJECT);

        thisElement->parent = NULL; /* Job Ticket has no parent               */
    
    }

/*** Return to Caller                                                         */
    FSG_SET_ERR(status);
    opDebugFlowOut("fsgjtNewDocument");
    return(status);

}

/**************************************|***************************************/
/* NOT IMPLEMENTED in this thin thread instantiation            API-150557    */
/* fsgjtNewDocumentFromURI - Creates a Document object using the provided URI */
/*                           that contains the document data.                 */
/*                                                                            */
/* param (output)   fsgjt_object_t*     document                              */
/*                  - Pointer to the new document to be created               */
/*                                                                            */
/* param (input)    fsgjt_uri_t         uri                                   */
/*                  - URI of the document data or NULL if no data file is     */
/*                    to be associated with the job ticket                    */
/*                                                                            */
/* return           fsgjt_return_code_t     (enum)                            */     
/*                                                                            */
/**************************************|***************************************/
/*                                                                            */
/* Revision Log                                                               */
/*      Date             Who                                                  */
/*      2007.08.22       Glen W. Petrie                                       */
/*    # Original code                                                         */
/*                                                                            */
/**************************************|***************************************/
/* NOT IMPLEMENTED in this thin thread instantiation            API-150557    */
/* NOT IMPLEMENTED in this thin thread instantiation            API-150557    */
/* NOT IMPLEMENTED in this thin thread instantiation            API-150557    */
/* NOT IMPLEMENTED in this thin thread instantiation            API-150557    */
/* NOT IMPLEMENTED in this thin thread instantiation            API-150557    */
fsgjt_return_code_t fsgjtNewDocumentFromURI(  /* OP_INT32  */

        fsgjt_object_t* document,             /* void**    */
        fsgjt_uri_t     uri                   /* char*     */

) {
/*** Declaration of Local Routine Variables                                   */
fsgjt_return_code_t  status;

/*** API Identifier Information for this Routine                              */
	OP_API_REG(150557, "fsgjtNewDocumentFromURI");

/*** Debug Flow Information for this Routine                                  */
    opDebugFlowIn("fsgjtNewDocumentFromURI");

/*** Initialization of Local Routine Variables                                */
    status = FSGJT_OK;

/*TT New Job Ticket Info From URI is not supported at this time               */
    FSG_SET_ERR(FSGJT_NOT_SUPPORTED);
    opDebugFlowOut("fsgjtNewDocumentFromURI");
    return(status);

/*** Return to Caller                                                         */
    FSG_SET_ERR(status);
    opDebugFlowOut("fsgjtNewDocumentFromURI");
    return(status);

}

/**************************************|***************************************/
/*                                                              API-150558    */
/* fsgjtNewFolding - Creates a Folding object having the provided folding     */
/*                   type.                                                    */
/*                                                                            */
/* param (output)   fsgjt_object_t*     folding                               */
/*                  - Pointer to the new Folding object to create             */
/*                                                                            */
/* param (input)    fsgjt_folding_type_t foldingType                          */
/*                  - Type of folding to be performed                         */
/*                                                                            */
/* return           fsgjt_return_code_t     (enum)                            */
/*                                                                            */
/**************************************|***************************************/
/*                                                                            */
/* Revision Log                                                               */
/*      Date             Who                                                  */
/*      2007.08.22       Glen W. Petrie                                       */
/*    # Original code                                                         */
/*                                                                            */
/**************************************|***************************************/
fsgjt_return_code_t fsgjtNewFolding(            /* OP_INT32  */

        fsgjt_object_t*         folding,        /* void**    */
        fsgjt_folding_type_t    foldingType     /* enum      */

) {
/*** Declaration of Local Routine Variables                                   */
fsgjt_return_code_t  status;
fsgjt_element_t*     thisElement;
fsgjt_element_t*     thisAttribute;

/*** API Identifier Information for this Routine                              */
	OP_API_REG(150558, "fsgjtNewFolding");

/*** Debug Flow Information for this Routine                                  */
    opDebugFlowIn("fsgjtNewFolding");

/*** Initialization of Local Routine Variables                                */
    status = FSGJT_OK;

/*** Create a element record                                                  */
    while (status == FSGJT_OK) {
        thisElement = CreateJtElement();
        if (thisElement == NULL) { status = FSGJT_INTERNAL_ERROR; break; }

        thisElement->data = NULL;

        thisElement->name = 
                (fsgjt_text_t)malloc(strlen(FSGJT_FOLDING_OBJECT));
        if (thisElement->name == NULL) { 
            status = FSGJT_INTERNAL_ERROR; 
            break; 
        }
        strcpy(thisElement->name, FSGJT_FOLDING_OBJECT);

        thisElement->type = 
                    (fsgjt_text_t)malloc(strlen(FSGJT_VT_FOLDING_OBJECT));
        if (thisElement->type == NULL) { 
            DestroyJtElement(thisElement); 
            status = FSGJT_INTERNAL_ERROR; 
            break; 
        }
        strcpy(thisElement->type, FSGJT_VT_FOLDING_OBJECT);

        thisElement->parent = NULL; /* Job Ticket has no parent               */
    
    /*** Set incoming Job Ticket type and version                             */
        status = fsgjtNewAttribute((void*)&thisAttribute,
                                   FSGJT_FOLDING_TYPE,
                                   FSGJT_VT_FOLDING_TYPE_ENUM,
                                   &foldingType);
        if (status != FSGJT_OK) { DestroyJtElement(thisElement); break; }
        thisAttribute->parent = (void*)thisElement;
    }

/*** Return to Caller                                                         */
    FSG_SET_ERR(status);
    opDebugFlowOut("fsgjtNewFolding");
    return(status);

}

/**************************************|***************************************/
/*                                                              API-150559    */
/* fsgjtNewForcePage - Creates a ForcePage object having the provided page    */
/*                     and sheet side.                                        */
/*                                                                            */
/* param (output)   fsgjt_object_t*     forcePage                             */
/*                  - Pointer to the new ForcePage object to create           */
/*                                                                            */
/* param (input)    fsgjt_int32_t       page                                  */
/*                  - Page number where the force page is to occur            */
/*                                                                            */
/* param (input)    fsgjt_sheet_side_t  sheetSide                             */
/*                  - Sheet side to force at the provided page number         */
/*                                                                            */
/* return           fsgjt_return_code_t     (enum)                            */
/*                                                                            */
/**************************************|***************************************/
/*                                                                            */
/* Revision Log                                                               */
/*      Date             Who                                                  */
/*      2007.08.22       Glen W. Petrie                                       */
/*    # Original code                                                         */
/*                                                                            */
/**************************************|***************************************/
fsgjt_return_code_t fsgjtNewForcePage(  /* OP_INT32  */

        fsgjt_object_t*     forcePage,  /* void**    */
        fsgjt_int32_t       page,       /* OP_INT32  */
        fsgjt_sheet_side_t  sheetSide   /* enum      */

) {
/*** Declaration of Local Routine Variables                                   */
fsgjt_return_code_t  status;
fsgjt_element_t*     thisElement;
fsgjt_element_t*     thisAttribute;

/*** API Identifier Information for this Routine                              */
	OP_API_REG(150559, "fsgjtNewForcePage");

/*** Debug Flow Information for this Routine                                  */
    opDebugFlowIn("fsgjtNewForcePage");

/*** Initialization of Local Routine Variables                                */
    status = FSGJT_OK;

/*** Create a element record                                                  */
    while (status == FSGJT_OK) {
        thisElement = CreateJtElement();
        if (thisElement == NULL) { status = FSGJT_INTERNAL_ERROR; break; }

        thisElement->data = NULL;

        thisElement->name = 
                (fsgjt_text_t)malloc(strlen(FSGJT_FORCE_PAGE_OBJECT));
        if (thisElement->name == NULL) { 
            status = FSGJT_INTERNAL_ERROR; 
            break; 
        }
        strcpy(thisElement->name, FSGJT_FORCE_PAGE_OBJECT);

        thisElement->type = 
                    (fsgjt_text_t)malloc(strlen(FSGJT_VT_FORCE_PAGE_OBJECT));
        if (thisElement->type == NULL) { 
            DestroyJtElement(thisElement); 
            status = FSGJT_INTERNAL_ERROR; 
            break; 
        }
        strcpy(thisElement->type, FSGJT_VT_FORCE_PAGE_OBJECT);

        thisElement->parent = NULL; /* Job Ticket has no parent               */
    
    /*** Set incoming Job Ticket type and version                             */
        status = fsgjtNewAttribute((void*)&thisAttribute,
                                   FSGJT_FORCE_PAGE_PAGE,
                                   FSGJT_VT_INTEGER,
                                   &page);
        if (status != FSGJT_OK) { DestroyJtElement(thisElement); break; }
        thisAttribute->parent = (void*)thisElement;

    /*** Set incoming Job Ticket type and version                             */
        status = fsgjtNewAttribute((void*)&thisAttribute,
                                   FSGJT_FORCE_PAGE_SHEET_SIDE,
                                   FSGJT_VT_SHEET_SIDE_ENUM,
                                   &sheetSide);
        if (status != FSGJT_OK) { DestroyJtElement(thisElement); break; }
        thisAttribute->parent = (void*)thisElement;
    }

/*** Return to Caller                                                         */
    FSG_SET_ERR(status);
    opDebugFlowOut("fsgjtNewForcePage");
    return(status);

}

/**************************************|***************************************/
/*                                                              API-150560    */
/* fsgjtNewHoleMaking - Creates a HoleMaking object having the provided hole  */
/*                      count.                                                */
/*                                                                            */
/* param (output)   fsgjt_object_t*     holeMaking                            */
/*                  - Pointer to the new HoleMaking object to create          */
/*                                                                            */
/* param (input)    fsgjt_int32_t       holeCount                             */
/*                  - Count of holes to make (punch, drill, etc.) for this    */
/*                    HoleMaking object                                       */
/*                                                                            */
/* return           fsgjt_return_code_t     (enum)                            */
/*                                                                            */
/**************************************|***************************************/
/*                                                                            */
/* Revision Log                                                               */
/*      Date             Who                                                  */
/*      2007.08.22       Glen W. Petrie                                       */
/*    # Original code                                                         */
/*                                                                            */
/**************************************|***************************************/
fsgjt_return_code_t fsgjtNewHoleMaking(  /* OP_INT32  */

        fsgjt_object_t* holeMaking,      /* void**    */
        fsgjt_int32_t   holeCount        /* OP_INT32  */

) {
/*** Declaration of Local Routine Variables                                   */
fsgjt_return_code_t  status;
fsgjt_element_t*     thisElement;
fsgjt_element_t*     thisAttribute;

/*** API Identifier Information for this Routine                              */
	OP_API_REG(150560, "fsgjtNewHoleMaking");

/*** Debug Flow Information for this Routine                                  */
    opDebugFlowIn("fsgjtNewHoleMaking");

/*** Initialization of Local Routine Variables                                */
    status = FSGJT_OK;

/*** Create a element record                                                  */
    while (status == FSGJT_OK) {
        thisElement = CreateJtElement();
        if (thisElement == NULL) { status = FSGJT_INTERNAL_ERROR; break; }

        thisElement->data = NULL;

        thisElement->name = 
                (fsgjt_text_t)malloc(strlen(FSGJT_HOLE_MAKING_OBJECT));
        if (thisElement->name == NULL) { 
            status = FSGJT_INTERNAL_ERROR; 
            break; 
        }
        strcpy(thisElement->name, FSGJT_HOLE_MAKING_OBJECT);

        thisElement->type = 
                    (fsgjt_text_t)malloc(strlen(FSGJT_VT_HOLE_MAKING_OBJECT));
        if (thisElement->type == NULL) { 
            DestroyJtElement(thisElement); 
            status = FSGJT_INTERNAL_ERROR; 
            break; 
        }
        strcpy(thisElement->type, FSGJT_VT_HOLE_MAKING_OBJECT);

        thisElement->parent = NULL; /* Job Ticket has no parent               */
    
    /*** Set incoming Job Ticket type and version                             */
        status = fsgjtNewAttribute((void*)&thisAttribute,
                                   FSGJT_HOLE_MAKING_COUNT,
                                   FSGJT_VT_INTEGER,
                                   &holeCount);
        if (status != FSGJT_OK) { DestroyJtElement(thisElement); break; }
        thisAttribute->parent = (void*)thisElement;
    }

/*** Return to Caller                                                         */
    FSG_SET_ERR(status);
    opDebugFlowOut("fsgjtNewHoleMaking");
    return(status);

}

/**************************************|***************************************/
/*                                                              API-150561    */
/* fsgjtNewInsertSheet - Creates a InsertSheet object having the provided     */
/*                       position and page ranges.                            */
/*                                                                            */
/* param (output)   fsgjt_object_t*     insertSheet                           */
/*                  - Pointer to the new InsertSheet object to create         */
/*                                                                            */
/* param (input)    fsgjt_position_t    position                              */
/*                  - Position of insert sheet (e.g., before)                 */
/*                                                                            */
/* param (input)    fsgjt_object_t*     pages                                 */
/*                  - List of PageRange objects (scope) for the insert        */
/*                    sheet operation                                         */
/*                                                                            */
/* return           fsgjt_return_code_t     (enum)                            */
/*                                                                            */
/**************************************|***************************************/
/*                                                                            */
/* Revision Log                                                               */
/*      Date             Who                                                  */
/*      2007.08.22       Glen W. Petrie                                       */
/*    # Original code                                                         */
/*                                                                            */
/**************************************|***************************************/
fsgjt_return_code_t fsgjtNewInsertSheet(  /* OP_INT32  */

        fsgjt_object_t*     insertSheet,  /* void**    */
        fsgjt_position_t    position,     /* enum      */
        fsgjt_object_t*     pages         /* void**    */

) {
/*** Declaration of Local Routine Variables                                   */
fsgjt_return_code_t  status;
fsgjt_element_t*     thisElement;
fsgjt_element_t*     thisAttribute;

/*** API Identifier Information for this Routine                              */
	OP_API_REG(150561, "fsgjtNewInsertSheet");

/*** Debug Flow Information for this Routine                                  */
    opDebugFlowIn("fsgjtNewInsertSheet");

/*** Initialization of Local Routine Variables                                */
    status = FSGJT_OK;

/*** Create a element record                                                  */
    while (status == FSGJT_OK) {
        thisElement = CreateJtElement();
        if (thisElement == NULL) { status = FSGJT_INTERNAL_ERROR; break; }

        thisElement->data = NULL;

        thisElement->name = 
                (fsgjt_text_t)malloc(strlen(FSGJT_INSERT_SHEET_OBJECT));
        if (thisElement->name == NULL) { 
            status = FSGJT_INTERNAL_ERROR; 
            break; 
        }
        strcpy(thisElement->name, FSGJT_INSERT_SHEET_OBJECT);

        thisElement->type = 
                    (fsgjt_text_t)malloc(strlen(FSGJT_VT_INSERT_SHEET_OBJECT));
        if (thisElement->type == NULL) { 
            DestroyJtElement(thisElement); 
            status = FSGJT_INTERNAL_ERROR; 
            break; 
        }
        strcpy(thisElement->type, FSGJT_VT_INSERT_SHEET_OBJECT);

        thisElement->parent = NULL; /* Job Ticket has no parent               */
    
    /*** Set incoming Job Ticket type and version                             */
        status = fsgjtNewAttribute((void*)&thisAttribute,
                                   FSGJT_INSERT_SHEET_POSITION,
                                   FSGJT_VT_POSITION_ENUM,
                                   &position);
        if (status != FSGJT_OK) { DestroyJtElement(thisElement); break; }
        thisAttribute->parent = (void*)thisElement;

    /*** Set incoming Job Ticket type and version                             */
        status = fsgjtNewAttribute((void*)&thisAttribute,
                                   FSGJT_INSERT_SHEET_PAGES,
                                   FSGJT_VT_PAGE_RANGE_OBJECT,
                                   pages);
        if (status != FSGJT_OK) { DestroyJtElement(thisElement); break; }
        thisAttribute->parent = (void*)thisElement;
    }

/*** Return to Caller                                                         */
    FSG_SET_ERR(status);
    opDebugFlowOut("fsgjtNewInsertSheet");
    return(status);

}

/**************************************|***************************************/
/*                                                              API-150562    */
/* fsgjtNewJob - Creates a Job without providing a Document.                  */
/*                                                                            */
/* param (output)   fsgjt_object_t*     job                                   */
/*                  - Pointer to Job object to be created                     */
/*                                                                            */
/* return           fsgjt_return_code_t     (enum)                            */
/*                                                                            */
/**************************************|***************************************/
/*                                                                            */
/* Revision Log                                                               */
/*      Date             Who                                                  */
/*      2007.08.22       Glen W. Petrie                                       */
/*    # Original code                                                         */
/*                                                                            */
/**************************************|***************************************/
fsgjt_return_code_t fsgjtNewJob(        /* OP_INT32  */

        fsgjt_object_t*     job         /* void**    */

) {
/*** Declaration of Local Routine Variables                                   */
fsgjt_return_code_t  status;
fsgjt_element_t*     thisElement;

/*** API Identifier Information for this Routine                              */
	OP_API_REG(150562, "fsgjtNewJob");

/*** Debug Flow Information for this Routine                                  */
    opDebugFlowIn("fsgjtNewJob");

/*** Initialization of Local Routine Variables                                */
    status = FSGJT_OK;

/*** Create a element record                                                  */
    while (status == FSGJT_OK) {
        thisElement = CreateJtElement();
        if (thisElement == NULL) { status = FSGJT_INTERNAL_ERROR; break; }

        thisElement->data = NULL;

        thisElement->name = 
                (fsgjt_text_t)malloc(strlen(FSGJT_JOB_OBJECT));
        if (thisElement->name == NULL) { 
            status = FSGJT_INTERNAL_ERROR; 
            break; 
        }
        strcpy(thisElement->name, FSGJT_JOB_OBJECT);

        thisElement->type = 
                    (fsgjt_text_t)malloc(strlen(FSGJT_VT_JOB_OBJECT));
        if (thisElement->type == NULL) { 
            DestroyJtElement(thisElement); 
            status = FSGJT_INTERNAL_ERROR; 
            break; 
        }
        strcpy(thisElement->type, FSGJT_VT_JOB_OBJECT);

        thisElement->parent = NULL; /* Job Ticket has no parent               */
    
    }

/*** Return to Caller                                                         */
    FSG_SET_ERR(status);
    opDebugFlowOut("fsgjtNewJob");
    return(status);

}

/**************************************|***************************************/
/* NOT IMPLEMENTED in this thin thread instantiation            API-150563    */
/* fsgjtNewJobFromDocument - Creates a Job containing the provided Document.  */
/*                                                                            */
/* param (output)   fsgjt_object_t*     job                                   */
/*                  - Pointer to Job object to be created                     */
/*                                                                            */
/* param (input)    fsgjt_object_t      document                              */
/*                  - Document to be contained in this job                    */
/*                                                                            */
/* return           fsgjt_return_code_t     (enum)                            */
/*                                                                            */
/**************************************|***************************************/
/*                                                                            */
/* Revision Log                                                               */
/*      Date             Who                                                  */
/*      2007.08.22       Glen W. Petrie                                       */
/*    # Original code                                                         */
/*                                                                            */
/**************************************|***************************************/
/* NOT IMPLEMENTED in this thin thread instantiation            API-150563    */
/* NOT IMPLEMENTED in this thin thread instantiation            API-150563    */
/* NOT IMPLEMENTED in this thin thread instantiation            API-150563    */
/* NOT IMPLEMENTED in this thin thread instantiation            API-150563    */
/* NOT IMPLEMENTED in this thin thread instantiation            API-150563    */
fsgjt_return_code_t fsgjtNewJobFromDocument(  /* OP_INT32  */

        fsgjt_object_t* job,                  /* void**    */
        fsgjt_object_t  document              /* void*     */

) {       
/*** Declaration of Local Routine Variables                                   */
fsgjt_return_code_t  status;

/*** API Identifier Information for this Routine                              */
	OP_API_REG(150563, "fsgjtNewJobFromDocument");

/*** Debug Flow Information for this Routine                                  */
    opDebugFlowIn("fsgjtNewJobFromDocument");

/*** Initialization of Local Routine Variables                                */
    status = FSGJT_OK;

/*TT New Job Ticket Info From URI is not supported at this time               */
    FSG_SET_ERR(FSGJT_NOT_SUPPORTED);
    opDebugFlowOut("fsgjtNewJobFromDocument");
    return(status);

/*** Return to Caller                                                         */
    FSG_SET_ERR(status);
    opDebugFlowOut("fsgjtNewJobFromDocument");
    return(status);

}

/**************************************|***************************************/
/*                                                              API-150564    */
/* fsgjtNewMedia - Creates a Media object using the provided name.            */
/*                                                                            */
/* param (output)   fsgjt_object_t*     media                                 */
/*                  - Pointer to the new Media to create                      */
/*                                                                            */
/* param (input)    fsgjt_text_t        name                                  */
/*                  - Name of the media or NULL if Media name is not being    */
/*                    specified.  The name can be any string.                 */
/*                                                                            */
/* return           fsgjt_return_code_t     (enum)                            */
/*                                                                            */
/**************************************|***************************************/
/*                                                                            */
/* Revision Log                                                               */
/*      Date             Who                                                  */
/*      2007.08.22       Glen W. Petrie                                       */
/*    # Original code                                                         */
/*                                                                            */
/**************************************|***************************************/
fsgjt_return_code_t fsgjtNewMedia(      /* OP_INT32  */

        fsgjt_object_t* media,          /* void**    */
        fsgjt_text_t    name            /* char*     */

) {
/*** Declaration of Local Routine Variables                                   */
fsgjt_return_code_t  status;
fsgjt_element_t*     thisElement;
fsgjt_element_t*     thisAttribute;

/*** API Identifier Information for this Routine                              */
	OP_API_REG(150564, "fsgjtNewMedia");

/*** Debug Flow Information for this Routine                                  */
    opDebugFlowIn("fsgjtNewMedia");

/*** Initialization of Local Routine Variables                                */
    status = FSGJT_OK;

/*** Create a element record                                                  */
    while (status == FSGJT_OK) {
        thisElement = CreateJtElement();
        if (thisElement == NULL) { status = FSGJT_INTERNAL_ERROR; break; }

        thisElement->data = NULL;

        thisElement->name = 
                (fsgjt_text_t)malloc(strlen(FSGJT_MEDIA_OBJECT));
        if (thisElement->name == NULL) { 
            status = FSGJT_INTERNAL_ERROR; 
            break; 
        }
        strcpy(thisElement->name, FSGJT_MEDIA_OBJECT);

        thisElement->type = 
                    (fsgjt_text_t)malloc(strlen(FSGJT_VT_MEDIA_OBJECT));
        if (thisElement->type == NULL) { 
            DestroyJtElement(thisElement); 
            status = FSGJT_INTERNAL_ERROR; 
            break; 
        }
        strcpy(thisElement->type, FSGJT_VT_MEDIA_OBJECT);

        thisElement->parent = NULL; /* Job Ticket has no parent               */
    
    /*** Set incoming Job Ticket type and version                             */
        status = fsgjtNewAttribute((void*)&thisAttribute,
                                   FSGJT_MEDIA_NAME,
                                   FSGJT_VT_TEXT,
                                   name);
        if (status != FSGJT_OK) { DestroyJtElement(thisElement); break; }
        thisAttribute->parent = (void*)thisElement;

    }

/*** Return to Caller                                                         */
    FSG_SET_ERR(status);
    opDebugFlowOut("fsgjtNewMedia");
    return(status);

}

/**************************************|***************************************/
/*                                                              API-150565    */
/* fsgjtNewPageRange - Creates a PageRange object having the provided lower   */
/*                     and upper bounds.                                      */
/*                                                                            */
/* param (output)   fsgjt_object_t*     pageRange                             */
/*                  - Pointer to the new PageRange object to create           */
/*                                                                            */
/* param (input)    fsgjt_int32_t       lower                                 */
/*                  - Page number where the page range is to begin(inclusive) */
/*                                                                            */
/* param (input)    fsgjt_int32_t       upper                                 */
/*                  - Page number where the page range is to end (inclusive)  */
/*                                                                            */
/* return           fsgjt_return_code_t     (enum)                            */
/*                                                                            */
/**************************************|***************************************/
/*                                                                            */
/* Revision Log                                                               */
/*      Date             Who                                                  */
/*      2007.08.22       Glen W. Petrie                                       */
/*    # Original code                                                         */
/*                                                                            */
/**************************************|***************************************/
fsgjt_return_code_t fsgjtNewPageRange(  /* OP_INT32  */

        fsgjt_object_t* pageRange,      /* void**    */
        fsgjt_int32_t   lower,          /* OP_INT32  */
        fsgjt_int32_t   upper           /* OP_INT32  */

) {
/*** Declaration of Local Routine Variables                                   */
fsgjt_return_code_t  status;
fsgjt_element_t*     thisElement;
fsgjt_element_t*     thisAttribute;

/*** API Identifier Information for this Routine                              */
	OP_API_REG(150565, "fsgjtNewPageRange");

/*** Debug Flow Information for this Routine                                  */
    opDebugFlowIn("fsgjtNewPageRange");

/*** Initialization of Local Routine Variables                                */
    status = FSGJT_OK;

/*** Create a element record                                                  */
    while (status == FSGJT_OK) {
        thisElement = CreateJtElement();
        if (thisElement == NULL) { status = FSGJT_INTERNAL_ERROR; break; }

        thisElement->data = NULL;

        thisElement->name = 
                (fsgjt_text_t)malloc(strlen(FSGJT_PAGE_RANGE_OBJECT));
        if (thisElement->name == NULL) { 
            status = FSGJT_INTERNAL_ERROR; 
            break; 
        }
        strcpy(thisElement->name, FSGJT_PAGE_RANGE_OBJECT);

        thisElement->type = 
                    (fsgjt_text_t)malloc(strlen(FSGJT_VT_PAGE_RANGE_OBJECT));
        if (thisElement->type == NULL) { 
            DestroyJtElement(thisElement); 
            status = FSGJT_INTERNAL_ERROR; 
            break; 
        }
        strcpy(thisElement->type, FSGJT_VT_PAGE_RANGE_OBJECT);

        thisElement->parent = NULL; /* Job Ticket has no parent               */
    
    /*** Set incoming Job Ticket type and version                             */
        status = fsgjtNewAttribute((void*)&thisAttribute,
                                   FSGJT_PAGE_RANGE_LOWER,
                                   FSGJT_VT_INTEGER,
                                   &lower);
        if (status != FSGJT_OK) { DestroyJtElement(thisElement); break; }
        thisAttribute->parent = (void*)thisElement;

    /*** Set incoming Job Ticket type and version                             */
        status = fsgjtNewAttribute((void*)&thisAttribute,
                                   FSGJT_PAGE_RANGE_UPPER,
                                   FSGJT_VT_INTEGER,
                                   &upper);
        if (status != FSGJT_OK) { DestroyJtElement(thisElement); break; }
        thisAttribute->parent = (void*)thisElement;
    }

/*** Return to Caller                                                         */
    FSG_SET_ERR(status);
    opDebugFlowOut("fsgjtNewPageRange");
    return(status);

}

/**************************************|***************************************/
/*                                                              API-150566    */
/* fsgjtNewSeparatorSheet - Creates a SeparatorSheet object having the        */
/*                          provided type and media.                          */
/*                                                                            */
/* param (output)   fsgjt_object_t*     separatorSheet                        */
/*                  - Pointer to the new SeparatorSheet object to create      */
/*                                                                            */
/* param (input)    fsgjt_separator_sheet_t type                              */
/*                  - Type of separator sheet (e.g., blank)                   */
/*                                                                            */
/* return           fsgjt_return_code_t     (enum)                            */
/*                                                                            */
/**************************************|***************************************/
/*                                                                            */
/* Revision Log                                                               */
/*      Date             Who                                                  */
/*      2007.08.22       Glen W. Petrie                                       */
/*    # Original code                                                         */
/*                                                                            */
/**************************************|***************************************/
fsgjt_return_code_t fsgjtNewSeparatorSheet(     /* OP_INT32  */

        fsgjt_object_t*         separatorSheet, /* void**    */
        fsgjt_separator_sheet_t type            /* enum      */

) { 
/*** Declaration of Local Routine Variables                                   */
fsgjt_return_code_t  status;
fsgjt_element_t*     thisElement;
fsgjt_element_t*     thisAttribute;

/*** API Identifier Information for this Routine                              */
	OP_API_REG(150566, "fsgjtNewSeparatorSheet");

/*** Debug Flow Information for this Routine                                  */
    opDebugFlowIn("fsgjtNewSeparatorSheet");

/*** Initialization of Local Routine Variables                                */
    status = FSGJT_OK;

/*** Create a element record                                                  */
    while (status == FSGJT_OK) {
        thisElement = CreateJtElement();
        if (thisElement == NULL) { status = FSGJT_INTERNAL_ERROR; break; }

        thisElement->data = NULL;

        thisElement->name = 
                (fsgjt_text_t)malloc(strlen(FSGJT_SEPARATOR_SHEET_OBJECT));
        if (thisElement->name == NULL) { 
            status = FSGJT_INTERNAL_ERROR; 
            break; 
        }
        strcpy(thisElement->name, FSGJT_SEPARATOR_SHEET_OBJECT);

        thisElement->type = 
                    (fsgjt_text_t)malloc(strlen(FSGJT_VT_SEPARATOR_SHEET_OBJECT));
        if (thisElement->type == NULL) { 
            DestroyJtElement(thisElement); 
            status = FSGJT_INTERNAL_ERROR; 
            break; 
        }
        strcpy(thisElement->type, FSGJT_VT_SEPARATOR_SHEET_OBJECT);

        thisElement->parent = NULL; /* Job Ticket has no parent               */
    
    /*** Set incoming Job Ticket type and version                             */
        status = fsgjtNewAttribute((void*)&thisAttribute,
                                   FSGJT_SEPARATOR_SHEET_TYPE,
                                   FSGJT_VT_SEPARATOR_SHEET_TYPE_ENUM,
                                   &type);
        if (status != FSGJT_OK) { DestroyJtElement(thisElement); break; }
        thisAttribute->parent = (void*)thisElement;

    }

/*** Return to Caller                                                         */
    FSG_SET_ERR(status);
    opDebugFlowOut("fsgjtNewSeparatorSheet");
    return(status);

}

/**************************************|***************************************/
/*                                                              API-150567    */
/* fsgjtNewStitching - Creates a Stitching object having the provided         */
/*                     stitching type.                                        */
/*                                                                            */
/* param (output)   fsgjt_object_t*     stitching                             */
/*                  - Pointer to the new Stitching object to create           */
/*                                                                            */
/* param (input)    fsgjt_stitching_type_t stitchingType                      */
/*                  - Type (edge, corner, etc.) for this Stitching object     */
/*                                                                            */
/* return           fsgjt_return_code_t     (enum)                            */
/*                                                                            */
/**************************************|***************************************/
/*                                                                            */
/* Revision Log                                                               */
/*      Date             Who                                                  */
/*      2007.08.22       Glen W. Petrie                                       */
/*    # Original code                                                         */
/*                                                                            */
/**************************************|***************************************/
fsgjt_return_code_t fsgjtNewStitching(          /* OP_INT32  */

        fsgjt_object_t*         stitching,      /* void**    */
        fsgjt_stitching_type_t  stitchingType   /* enum      */

) {
/*** Declaration of Local Routine Variables                                   */
fsgjt_return_code_t  status;
fsgjt_element_t*     thisElement;
fsgjt_element_t*     thisAttribute;

/*** API Identifier Information for this Routine                              */
	OP_API_REG(150567, "fsgjtNewStitching");

/*** Debug Flow Information for this Routine                                  */
    opDebugFlowIn("fsgjtNewStitching");

/*** Initialization of Local Routine Variables                                */
    status = FSGJT_OK;

/*** Create a element record                                                  */
    while (status == FSGJT_OK) {
        thisElement = CreateJtElement();
        if (thisElement == NULL) { status = FSGJT_INTERNAL_ERROR; break; }

        thisElement->data = NULL;

        thisElement->name = 
                (fsgjt_text_t)malloc(strlen(FSGJT_STITCHING_OBJECT));
        if (thisElement->name == NULL) { 
            status = FSGJT_INTERNAL_ERROR; 
            break; 
        }
        strcpy(thisElement->name, FSGJT_STITCHING_OBJECT);

        thisElement->type = 
                    (fsgjt_text_t)malloc(strlen(FSGJT_VT_STITCHING_OBJECT));
        if (thisElement->type == NULL) { 
            DestroyJtElement(thisElement); 
            status = FSGJT_INTERNAL_ERROR; 
            break; 
        }
        strcpy(thisElement->type, FSGJT_VT_STITCHING_OBJECT);

        thisElement->parent = NULL; /* Job Ticket has no parent               */
    
    /*** Set incoming Job Ticket type and version                             */
        status = fsgjtNewAttribute((void*)&thisAttribute,
                                   FSGJT_STITCHING_TYPE,
                                   FSGJT_VT_STITCHING_TYPE_ENUM,
                                   &stitchingType);
        if (status != FSGJT_OK) { DestroyJtElement(thisElement); break; }
        thisAttribute->parent = (void*)thisElement;

    }

/*** Return to Caller                                                         */
    FSG_SET_ERR(status);
    opDebugFlowOut("fsgjtNewStitching");
    return(status);

}

/**************************************|***************************************/
/*                                                              API-150568    */
/* fsgjtNewSubscription - Creates a Subscription object having the provided   */
/*                        notification URI.                                   */
/*                                                                            */
/* param (output)   fsgjt_object_t*     subscription                          */
/*                  - Pointer to the new Subscription object to create        */
/*                                                                            */
/* param (input)    fsgjt_uri_t         sendToUri                             */
/*                  - URI for delivery of notifications for this Subscription */
/*                                                                            */
/* return           fsgjt_return_code_t     (enum)                            */
/*                                                                            */
/**************************************|***************************************/
/*                                                                            */
/* Revision Log                                                               */
/*      Date             Who                                                  */
/*      2007.08.22       Glen W. Petrie                                       */
/*    # Original code                                                         */
/*                                                                            */
/**************************************|***************************************/
fsgjt_return_code_t fsgjtNewSubscription(  /* OP_INT32  */

        fsgjt_object_t*     subscription,  /* void**    */
        fsgjt_uri_t         sendToUri      /* char*     */

) {
/*** Declaration of Local Routine Variables                                   */
fsgjt_return_code_t  status;
fsgjt_element_t*     thisElement;
fsgjt_element_t*     thisAttribute;

/*** API Identifier Information for this Routine                              */
	OP_API_REG(150568, "fsgjtNewSubscription");

/*** Debug Flow Information for this Routine                                  */
    opDebugFlowIn("fsgjtNewSubscription");

/*** Initialization of Local Routine Variables                                */
    status = FSGJT_OK;

/*** Create a element record                                                  */
    while (status == FSGJT_OK) {
        thisElement = CreateJtElement();
        if (thisElement == NULL) { status = FSGJT_INTERNAL_ERROR; break; }

        thisElement->data = NULL;

        thisElement->name = 
                (fsgjt_text_t)malloc(strlen(FSGJT_SUBSCRIPTION_OBJECT));
        if (thisElement->name == NULL) { 
            status = FSGJT_INTERNAL_ERROR; 
            break; 
        }
        strcpy(thisElement->name, FSGJT_SUBSCRIPTION_OBJECT);

        thisElement->type = 
                    (fsgjt_text_t)malloc(strlen(FSGJT_VT_SUBSCRIPTION_OBJECT));
        if (thisElement->type == NULL) { 
            DestroyJtElement(thisElement); 
            status = FSGJT_INTERNAL_ERROR; 
            break; 
        }
        strcpy(thisElement->type, FSGJT_VT_SUBSCRIPTION_OBJECT);

        thisElement->parent = NULL; /* Job Ticket has no parent               */
    
    /*** Set incoming Job Ticket type and version                             */
        status = fsgjtNewAttribute((void*)&thisAttribute,
                                   FSGJT_SUBSCRIPTION_SEND_TO_URI,
                                   FSGJT_VT_URI,
                                   sendToUri);
        if (status != FSGJT_OK) { DestroyJtElement(thisElement); break; }
        thisAttribute->parent = (void*)thisElement;

    }

/*** Return to Caller                                                         */
    FSG_SET_ERR(status);
    opDebugFlowOut("fsgjtNewSubscription");
    return(status);

}

/*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%|%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%*/
/*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%|%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%*/
/*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%|%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%*/
/*  Destroy Destroy Destroy Destroy Destroy Destroy Destroy Destroy Destroy   */
/*  Objects Objects Objects Objects Objects Objects Objects Objects Objects   */
/* -------------------------------------------------------------------------- */
/* -------------------------------------------------------------------------- */
/*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%|%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%*/
/*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%|%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%*/
/*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%|%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%*/

/**************************************|***************************************/
/*                                                              API-150600    */
/* fsgjtDestroy - Free the memory used by the provided object.                */
/*                                                                            */  
/* param (input)    fsgjt_object_t      object                                */
/*                  - Object to free                                          */
/*                                                                            */
/* return           fsgjt_return_code_t     (enum)                            */
/*                                                                            */
/**************************************|***************************************/
/*                                                                            */
/* Revision Log                                                               */
/*      Date             Who                                                  */
/*      2007.08.07       Glen W. Petrie                                       */
/*    # Original code                                                         */
/*                                                                            */
/**************************************|***************************************/
fsgjt_return_code_t fsgjtDestroy(       /* OP_INT32  */

        fsgjt_object_t  object          /* void*     */

) {
/*** Declaration of Local Routine Variables                                   */
fsgjt_return_code_t  status;

/*** API Identifier Information for this Routine                              */
	OP_API_REG(150600, "fsgjtDestroy");

/*** Debug Flow Information for this Routine                                  */
    opDebugFlowIn("fsgjtDestroy");

/*** Initialization of Local Routine Variables                                */
    status = FSGJT_OK;

/*** Return to Caller                                                         */
    FSG_SET_ERR(status);
    opDebugFlowOut("fsgjtDestroy");
    return(status);

}

/*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%|%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%*/
/*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%|%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%*/
/*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%|%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%*/
/*         Write      Write      Write      Write      Write      Write       */
/*      Job-Ticket Job-Ticket Job-Ticket Job-Ticket Job-Ticket Job-Ticket     */
/* -------------------------------------------------------------------------- */
/* -------------------------------------------------------------------------- */
/*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%|%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%*/
/*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%|%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%*/
/*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%|%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%*/

/**************************************|***************************************/
/*                                                              API-150650    */
/* fsgjtWriteJobTicketToBuffer - Writes a job ticket to the provided buffer.  */
/*                               The caller should pass a _large_ buffer to   */
/*                               avoid failure due to buffer overrun.  The    */
/*                               caller may then use C standard 'realloc()'   */
/*                               to 'trim' the buffer.                        */
/*                                                                            */
/* param (input)    fsgjt_object_t      jobTicketInfo                         */
/*                  - JobTicketInfo from which job ticket is to be written    */
/*                                                                            */
/* param (output)   fsgjt_text_t        buffer                                */
/*                  - Buffer to write the job ticket to.  The buffer must     */
/*                    be created by the caller.                               */
/*                                                                            */
/* param (input/output) fsgjt_int32_t*  bufferSize                            */
/*                  - Size of buffer that the caller created and the returned */
/*                    size of the data written to the buffer (i.e., length of */
/*                    the serialized job ticket) for 'trimming'.              */
/*                                                                            */
/* return           fsgjt_return_code_t     (enum)                            */
/*                                                                            */
/**************************************|***************************************/
/*                                                                            */
/* Revision Log                                                               */
/*      Date             Who                                                  */
/*      2007.08.07       Glen W. Petrie                                       */
/*    # Original code                                                         */
/*                                                                            */
/**************************************|***************************************/
fsgjt_return_code_t fsgjtWriteJobTicketToBuffer(  /* OP_INT32  */

        fsgjt_object_t  jobTicketInfo,            /* void*     */
        fsgjt_text_t    buffer,                   /* char*     */
        fsgjt_int32_t*  bufferSize                /* OP_INT32* */

) {
/*** Declaration of Local Routine Variables                                   */
fsgjt_return_code_t  status;

/*** API Identifier Information for this Routine                              */
	OP_API_REG(150650, "fsgjtWriteJobTicketToBuffer");

/*** Debug Flow Information for this Routine                                  */
    opDebugFlowIn("fsgjtWriteJobTicketToBuffer");

/*** Initialization of Local Routine Variables                                */
    status = FSGJT_OK;

/*** Return to Caller                                                         */
    FSG_SET_ERR(status);
    opDebugFlowOut("fsgjtWriteJobTicketToBuffer");
    return(status);

}

/**************************************|***************************************/
/*                                                              API-150651    */
/* fsgjtWriteJobTicketToURI - Writes a job ticket at the provided URI.        */
/*                                                                            */
/* param (input)    fsgjt_object_t      jobTicketInfo                         */
/*                  - JobTicketInfo from which job ticket is to be written    */
/*                                                                            */
/* param (output)   fsgjt_uri_t         uri                                   */
/*                  - URI of the job ticket that is to be created from the    */
/*                    JobTicketInfo.                                          */
/*                                                                            */
/* return           fsgjt_return_code_t     (enum)                            */
/*                                                                            */
/**************************************|***************************************/
/*                                                                            */
/* Revision Log                                                               */
/*      Date             Who                                                  */
/*      2007.08.07       Glen W. Petrie                                       */
/*    # Original code                                                         */
/*                                                                            */
/**************************************|***************************************/
fsgjt_return_code_t fsgjtWriteJobTicketToURI(  /* OP_INT32  */

        fsgjt_object_t  jobTicketInfo,         /* void*     */
        fsgjt_uri_t     uri                    /* char*     */

) {
/*** Declaration of Local Routine Variables                                   */
fsgjt_return_code_t  status;

/*** API Identifier Information for this Routine                              */
	OP_API_REG(150651, "fsgjtWriteJobTicketToURI");

/*** Debug Flow Information for this Routine                                  */
    opDebugFlowIn("fsgjtWriteJobTicketToURI");

/*** Initialization of Local Routine Variables                                */
    status = FSGJT_OK;

/*** Return to Caller                                                         */
    FSG_SET_ERR(status);
    opDebugFlowOut("fsgjtWriteJobTicketToURI");
    return(status);

}

/*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%|%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%*/
/*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%|%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%*/
/*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%|%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%*/
/*       Create     Create     Create     Create     Create     Create        */
/*     Attributes Attributes Attributes Attributes Attributes Attributes      */
/*       /Values    /Values    /Values    /Values    /Values    /Values       */
/* -------------------------------------------------------------------------- */
/* -------------------------------------------------------------------------- */
/*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%|%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%*/
/*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%|%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%*/
/*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%|%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%*/

/**************************************|***************************************/
/*                                                              API-150700    */
/* fsgjtNewAttribute - Creates a new Attribute object having the provided     */
/*                     attribute name, value type, and value.                 */
/*                                                                            */
/* param (output)   fsgjt_attribute_t*  attribute                             */
/*                  - Pointer to the new Attribute returned.                  */
/*                                                                            */
/* param (input)    fsgjt_text_t        name                                  */
/*                  - Name for the new Attribute to create                    */
/*                                                                            */
/* param (input)    fsgjt_text_t        type                                  */
/*                  - Type for the new Attribute to create (use Value Types)  */
/*                                                                            */
/* param (input)    void*               value                                 */
/*                  - Pointer to value for this attribute.  Multiple values   */
/*                    should be added with the fsgjtAddValue() function.      */
/*                                                                            */
/* return           fsgjt_return_code_t     (enum)                            */
/*                                                                            */
/**************************************|***************************************/
/*                                                                            */
/* Revision Log                                                               */
/*      Date             Who                                                  */
/*      2007.08.07       Glen W. Petrie                                       */
/*    # Original code                                                         */
/*                                                                            */
/**************************************|***************************************/
fsgjt_return_code_t fsgjtNewAttribute(  /* OP_INT32  */

        fsgjt_attribute_t*  attribute,  /* void**    */
        fsgjt_text_t        name,       /* char*     */
        fsgjt_text_t        type,       /* char*     */
        void*               value       /* void*     */

) {
/*** Declaration of Local Routine Variables                                   */
fsgjt_return_code_t  status;

/*** API Identifier Information for this Routine                              */
	OP_API_REG(150700, "fsgjtNewAttribute");

/*** Debug Flow Information for this Routine                                  */
    opDebugFlowIn("fsgjtNewAttribute");

/*** Initialization of Local Routine Variables                                */
    status = FSGJT_OK;

/*** Return to Caller                                                         */
    FSG_SET_ERR(status);
    opDebugFlowOut("fsgjtNewAttribute");
    return(status);

}

/*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%|%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%*/
/*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%|%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%*/
/*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%|%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%*/
/*         Set/       Set/       Set/       Set/       Set/       Set/        */
/*       Replace    Replace    Replace    Replace    Replace    Replace       */
/*     Attributes Attributes Attributes Attributes Attributes Attributes      */
/* -------------------------------------------------------------------------- */
/*        Add        Add        Add        Add        Add        Add          */
/*       Value      Value      Value      Value      Value      Value         */
/* -------------------------------------------------------------------------- */
/*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%|%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%*/
/*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%|%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%*/
/*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%|%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%*/

/**************************************|***************************************/
/*                                                              API-150750    */
/* fsgjtSet - Sets the provided attribute for the provided object.            */
/*                                                                            */
/* param (input)    fsgjt_object_t      object                                */
/*                  - Object in which to set the Attribute                    */
/*                                                                            */
/* param (input)    fsgjt_attribute_t   attribute                             */
/*                  - Attribute to set                                        */
/*                                                                            */
/* return -         fsgjt_return_code_t     (enum)                            */
/*                                                                            */
/**************************************|***************************************/
/*                                                                            */
/* Revision Log                                                               */
/*      Date             Who                                                  */
/*      2007.08.07       Glen W. Petrie                                       */
/*    # Original code                                                         */
/*                                                                            */
/**************************************|***************************************/
fsgjt_return_code_t fsgjtSet(           /* OP_INT32  */

        fsgjt_object_t      object,     /* void*     */
        fsgjt_attribute_t   attribute   /* void*     */

) {
/*** Declaration of Local Routine Variables                                   */
fsgjt_return_code_t  status;

/*** API Identifier Information for this Routine                              */
	OP_API_REG(150750, "fsgjtSet");

/*** Debug Flow Information for this Routine                                  */
    opDebugFlowIn("fsgjtSet");

/*** Initialization of Local Routine Variables                                */
    status = FSGJT_OK;

/*** Return to Caller                                                         */
    FSG_SET_ERR(status);
    opDebugFlowOut("fsgjtSet");
    return(status);

}

/***                         Convenience function for ...                     */
/**************************************|***************************************/
/*                                                              API-150751    */
/* fsgjtSetIntegerAttribute - Setting an integer Attribute to the provided    */
/*                            value.  This function creates a                 */
/*                            fsgjt_attribute_t and calls fsgjtSet() function */
/*                            and then destroys the temporary Attribute.      */
/*                                                                            */
/* param (input)    fsgjt_object_t      object                                */
/*                  - Set the Attribute in this object                        */
/*                                                                            */
/* param (input)    fsgjt_text_t        attributeName                         */
/*                  - Name of Attribute to set                                */
/*                                                                            */
/* param (input)    fsgjt_int32_t       value                                 */
/*                  - New value for the Attribute                             */
/*                                                                            */
/* return           fsgjt_return_code_t     (enum)                            */
/*                                                                            */
/**************************************|***************************************/
/*                                                                            */
/* Revision Log                                                               */
/*      Date             Who                                                  */
/*      2007.08.07       Glen W. Petrie                                       */
/*    # Original code                                                         */
/*                                                                            */
/**************************************|***************************************/
fsgjt_return_code_t fsgjtSetIntegerAttribute(  /* OP_INT32  */

        fsgjt_object_t  object,                /* void*     */
        fsgjt_text_t    attributeName,         /* char*     */
        fsgjt_int32_t   value                  /* OP_INT32  */

) {
/*** Declaration of Local Routine Variables                                   */
fsgjt_return_code_t  status;

/*** API Identifier Information for this Routine                              */
	OP_API_REG(150751, "fsgjtSetIntegerAttribute");

/*** Debug Flow Information for this Routine                                  */
    opDebugFlowIn("fsgjtSetIntegerAttribute");

/*** Initialization of Local Routine Variables                                */
    status = FSGJT_OK;

/*** Return to Caller                                                         */
    FSG_SET_ERR(status);
    opDebugFlowOut("fsgjtSetIntegerAttribute");
    return(status);

}

/***                         Convenience function for ...                     */
/**************************************|***************************************/
/*                                                              API-150752    */
/* fsgjtSetObjectAttribute - Setting an object Attribute to the provided      */
/*                           value. This function creates a fsgjt_attribute_t */
/*                           and calls fsgjtSet() function and then destroys  */
/*                           the temporary Attribute.                         */
/*                                                                            */
/* param (input)    fsgjt_object_t      object                                */
/*                  - Set the Attribute in this object                        */
/*                                                                            */
/* param (input)    fsgjt_text_t        attributeName                         */
/*                  - Name of Attribute to set                                */
/*                                                                            */
/* param (input)    fsgjt_object_t      value                                 */
/*                  - New value for the Attribute                             */
/*                                                                            */
/* return           fsgjt_return_code_t     (enum)                            */
/*                                                                            */
/**************************************|***************************************/
/*                                                                            */
/* Revision Log                                                               */
/*      Date             Who                                                  */
/*      2007.08.07       Glen W. Petrie                                       */
/*    # Original code                                                         */
/*                                                                            */
/**************************************|***************************************/
fsgjt_return_code_t fsgjtSetObjectAttribute(  /* OP_INT32  */

        fsgjt_object_t  object,               /* void*     */
        fsgjt_text_t    attributeName,        /* char*     */
        fsgjt_object_t  value                 /* void*     */

) {
/*** Declaration of Local Routine Variables                                   */
fsgjt_return_code_t  status;

/*** API Identifier Information for this Routine                              */
	OP_API_REG(150752, "fsgjtSetObjectAttribute");

/*** Debug Flow Information for this Routine                                  */
    opDebugFlowIn("fsgjtSetObjectAttribute");

/*** Initialization of Local Routine Variables                                */
    status = FSGJT_OK;

/*** Return to Caller                                                         */
    FSG_SET_ERR(status);
    opDebugFlowOut("fsgjtSetObjectAttribute");
    return(status);

}

/***                         Convenience function for ...                     */
/**************************************|***************************************/
/*                                                              API-150753    */
/* fsgjtSetObjectAttributeList - Setting an object Attribute to the provided  */
/*                               list of values. This function creates a      */
/*                               fsgjt_attribute_t, adds the values and calls */
/*                               fsgjtSet() function, and then destroys the   */
/*                               temporary Attribute.                         */
/*                                                                            */
/* param (input)    fsgjt_object_t      object                                */
/*                  - Set the Attribute in this object                        */
/*                                                                            */
/* param (input)    fsgjt_text_t        attributeName                         */
/*                  - Name of Attribute to set                                */
/*                                                                            */
/* param (input)    fsgjt_object_t*     value                                 */
/*                  - List of new values for the Attribute                    */
/*                                                                            */
/* return           fsgjt_return_code_t     (enum)                            */
/*                                                                            */
/**************************************|***************************************/
/*                                                                            */
/* Revision Log                                                               */
/*      Date             Who                                                  */
/*      2007.08.07       Glen W. Petrie                                       */
/*    # Original code                                                         */
/*                                                                            */
/**************************************|***************************************/
fsgjt_return_code_t fsgjtSetObjectAttributeList(  /* OP_INT32  */

        fsgjt_object_t  object,                   /* void*     */
        fsgjt_text_t    attributeName,            /* char*     */
        fsgjt_object_t* list                      /* void*[]   */

) {
/*** Declaration of Local Routine Variables                                   */
fsgjt_return_code_t  status;

/*** API Identifier Information for this Routine                              */
	OP_API_REG(150753, "fsgjtSetObjectAttributeList");

/*** Debug Flow Information for this Routine                                  */
    opDebugFlowIn("fsgjtSetObjectAttributeList");

/*** Initialization of Local Routine Variables                                */
    status = FSGJT_OK;

/*** Return to Caller                                                         */
    FSG_SET_ERR(status);
    opDebugFlowOut("fsgjtSetObjectAttributeList");
    return(status);

}

/***                         Convenience function for ...                     */
/**************************************|***************************************/
/*                                                              API-150754    */
/* fsgjtSetTextAttribute - Setting a text Attribute to the provided value.    */
/*                         This function creates a fsgjt_attribute_t, calls   */
/*                         fsgjtSet() function, and then destroys the         */
/*                         temporary Attribute.                               */
/*                                                                            */
/* param (input)    fsgjt_object_t      object                                */
/*                  - Set the Attribute in this object                        */
/*                                                                            */
/* param (input)    fsgjt_text_t        attributeName                         */
/*                  - Name of Attribute to set                                */
/*                                                                            */
/* param (input)    fsgjt_text_t        value                                 */
/*                  - New value for the Attribute                             */
/*                                                                            */
/* return           fsgjt_return_code_t     (enum)                            */
/*                                                                            */
/**************************************|***************************************/
/*                                                                            */
/* Revision Log                                                               */
/*      Date             Who                                                  */
/*      2007.08.07       Glen W. Petrie                                       */
/*    # Original code                                                         */
/*                                                                            */
/**************************************|***************************************/
fsgjt_return_code_t fsgjtSetTextAttribute(  /* OP_INT32  */

        fsgjt_object_t  object,             /* void*     */
        fsgjt_text_t    attributeName,      /* char*     */
        fsgjt_text_t    value               /* char*     */

) {
/*** Declaration of Local Routine Variables                                   */
fsgjt_return_code_t  status;

/*** API Identifier Information for this Routine                              */
	OP_API_REG(150754, "fsgjtSetTextAttribute");

/*** Debug Flow Information for this Routine                                  */
    opDebugFlowIn("fsgjtSetTextAttribute");

/*** Initialization of Local Routine Variables                                */
    status = FSGJT_OK;

/*** Return to Caller                                                         */
    FSG_SET_ERR(status);
    opDebugFlowOut("fsgjtSetTextAttribute");
    return(status);

}


/***                         Convenience function for ...                     */
/**************************************|***************************************/
/*                                                              API-150755    */
/* fsgjtSetTextAttributeList - Setting a text Attribute to the provided       */
/*                             values. This function creates a                */
/*                             fsgjt_attribute_t, calls fsgjtSet() function,  */
/*                             and then destroys the temporary Attribute.     */
/*                                                                            */
/* param (input)    fsgjt_object_t      object                                */
/*                  - Set the Attribute in this object                        */
/*                                                                            */
/* param (input)    fsgjt_text_t        attributeName                         */
/*                  - Name of Attribute to set                                */
/*                                                                            */
/* param (input)    fsgjt_text_t*       values                                */
/*                  - List of new values for the Attribute                    */
/*                                                                            */
/* return           fsgjt_return_code_t     (enum)                            */
/*                                                                            */
/**************************************|***************************************/
/*                                                                            */
/* Revision Log                                                               */
/*      Date             Who                                                  */
/*      2007.08.07       Glen W. Petrie                                       */
/*    # Original code                                                         */
/*                                                                            */
/**************************************|***************************************/
fsgjt_return_code_t fsgjtSetTextAttributeList(  /* OP_INT32  */

        fsgjt_object_t  object,                 /* void*     */
        fsgjt_text_t    attributeName,          /* char*     */
        fsgjt_text_t*   values                  /* char**    */

) {
/*** Declaration of Local Routine Variables                                   */
fsgjt_return_code_t  status;

/*** API Identifier Information for this Routine                              */
	OP_API_REG(150755, "fsgjtSetTextAttributeList");

/*** Debug Flow Information for this Routine                                  */
    opDebugFlowIn("fsgjtSetTextAttributeList");

/*** Initialization of Local Routine Variables                                */
    status = FSGJT_OK;

/*** Return to Caller                                                         */
    FSG_SET_ERR(status);
    opDebugFlowOut("fsgjtSetTextAttributeList");
    return(status);

}

/**************************************|***************************************/
/*                                                              API-150756    */
/* fsgjtReplaceValue - Replaces the existing values for this Attribute with   */
/*                     the provided value.                                    */
/*                                                                            */
/* param (input)    fsgjt_attribute_t   attribute                             */
/*                  - Attribute to replace the existing values                */
/*                                                                            */
/* param (input)    void*               value                                 */
/*                  - Pointer to replacement value                            */
/*                                                                            */
/* return           fsgjt_return_code_t     (enum)                            */
/*                                                                            */
/**************************************|***************************************/
/*                                                                            */
/* Revision Log                                                               */
/*      Date             Who                                                  */
/*      2007.08.07       Glen W. Petrie                                       */
/*    # Original code                                                         */
/*                                                                            */
/**************************************|***************************************/
fsgjt_return_code_t fsgjtReplaceValue(  /* OP_INT32  */

        fsgjt_attribute_t   attribute,  /* void*     */
        void*               value       /* void*     */

) {
/*** Declaration of Local Routine Variables                                   */
fsgjt_return_code_t  status;

/*** API Identifier Information for this Routine                              */
	OP_API_REG(150756, "fsgjtReplaceValue");

/*** Debug Flow Information for this Routine                                  */
    opDebugFlowIn("fsgjtReplaceValue");

/*** Initialization of Local Routine Variables                                */
    status = FSGJT_OK;

/*** Return to Caller                                                         */
    FSG_SET_ERR(status);
    opDebugFlowOut("fsgjtReplaceValue");
    return(status);

}

/**************************************|***************************************/
/*                                                              API-150757    */
/* fsgjtAddValue - Add an additional value to this Attribute.                 */
/*                                                                            */
/* param (input)    fsgjt_attribute_t   attribute                             */
/*                  - Attribute to add the provided value to                  */
/*                                                                            */
/* param (input)    void*               value                                 */
/*                  - Pointer to value to add                                 */
/*                                                                            */
/* return           fsgjt_return_code_t     (enum)                            */
/*                                                                            */
/**************************************|***************************************/
/*                                                                            */
/* Revision Log                                                               */
/*      Date             Who                                                  */
/*      2007.08.07       Glen W. Petrie                                       */
/*    # Original code                                                         */
/*                                                                            */
/**************************************|***************************************/
fsgjt_return_code_t fsgjtAddValue(      /* OP_INT32  */

        fsgjt_attribute_t   attribute,  /* void*     */
        void*               value       /* void*     */

) {
/*** Declaration of Local Routine Variables                                   */
fsgjt_return_code_t  status;

/*** API Identifier Information for this Routine                              */
	OP_API_REG(150757, "fsgjtAddValue");

/*** Debug Flow Information for this Routine                                  */
    opDebugFlowIn("fsgjtAddValue");

/*** Initialization of Local Routine Variables                                */
    status = FSGJT_OK;

/*** Return to Caller                                                         */
    FSG_SET_ERR(status);
    opDebugFlowOut("fsgjtAddValue");
    return(status);

}

/*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%|%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%*/
/*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%|%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%*/
/*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%|%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%*/
/*         Get        Get        Get        Get        Get        Get         */
/*     Attributes Attributes Attributes Attributes Attributes Attributes      */
/* -------------------------------------------------------------------------- */
/* -------------------------------------------------------------------------- */
/*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%|%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%*/
/*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%|%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%*/
/*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%|%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%*/

/**************************************|***************************************/
/*                                                              API-150800    */
/* fsgjtGet - Gets the Attribute having the provided name.                    */
/*                                                                            */
/* param (input)    fsgjt_object_t      object                                */
/*                  - Object from which to get the Attribute                  */
/*                                                                            */
/* param (input)    fsgjt_text_t        attributeName                         */
/*                  - Name of the Attribute to get                            */
/*                                                                            */
/* param (output)   fsgjt_attribute_t*  attribute                             */
/*                  - Pointer to Attribute having provided name               */
/*                                                                            */
/* return           fsgjt_return_code_t     (enum)                            */
/*                                                                            */
/**************************************|***************************************/
/*                                                                            */
/* Revision Log                                                               */
/*      Date             Who                                                  */
/*      2007.08.07       Glen W. Petrie                                       */
/*    # Original code                                                         */
/*                                                                            */
/**************************************|***************************************/
fsgjt_return_code_t fsgjtGet(               /* OP_INT32  */

        fsgjt_object_t      object,         /* void*     */
        fsgjt_text_t        attributeName,  /* char*     */
        fsgjt_attribute_t*  attribute       /* void**    */

) {
/*** Declaration of Local Routine Variables                                   */
fsgjt_return_code_t  status;

/*** API Identifier Information for this Routine                              */
	OP_API_REG(150800, "fsgjtGet");

/*** Debug Flow Information for this Routine                                  */
    opDebugFlowIn("fsgjtGet");

/*** Initialization of Local Routine Variables                                */
    status = FSGJT_OK;

/*** Return to Caller                                                         */
    FSG_SET_ERR(status);
    opDebugFlowOut("fsgjtGet");
    return(status);

}

/**************************************|***************************************/
/*                                                              API-150801    */
/* fsgjtGetName - Get the name of the Attribute.                              */
/*                                                                            */
/* param (input)    fsgjt_attribute_t   attribute                             */
/*                  - Attribute whose name to get                             */
/*                                                                            */
/* param (output)   fsgjt_text_t*       name                                  */
/*                  - Name of the Attribute                                   */
/*                                                                            */
/* return           fsgjt_return_code_t     (enum)                            */
/*                                                                            */
/**************************************|***************************************/
/*                                                                            */
/* Revision Log                                                               */
/*      Date             Who                                                  */
/*      2007.08.07       Glen W. Petrie                                       */
/*    # Original code                                                         */
/*                                                                            */
/**************************************|***************************************/
fsgjt_return_code_t fsgjtGetName(       /* OP_INT32  */

        fsgjt_attribute_t   attribute,  /* void*     */
        fsgjt_text_t*       name        /* char**    */

) { 
/*** Declaration of Local Routine Variables                                   */
fsgjt_return_code_t  status;

/*** API Identifier Information for this Routine                              */
	OP_API_REG(150801, "fsgjtGetName");

/*** Debug Flow Information for this Routine                                  */
    opDebugFlowIn("fsgjtGetName");

/*** Initialization of Local Routine Variables                                */
    status = FSGJT_OK;

/*** Return to Caller                                                         */
    FSG_SET_ERR(status);
    opDebugFlowOut("fsgjtGetName");
    return(status);

}

/**************************************|***************************************/
/*                                                              API-150802    */
/* fsgjtGetNextValue - Return the Attribute's next value.                     */
/*                                                                            */
/* param (input)    fsgjt_attribute_t   attribute                             */
/*                  - Attribute whose next value is to be returned            */
/*                                                                            */
/* param (output)   void**              nextValue                             */
/*                  - Pointer to the next value                               */
/*                                                                            */
/* param (output)   fsgjt_present_t*    moreValues                            */
/*                  - On if there are more values for the Attribute other     */
/*                    than the value being returned                           */
/*                                                                            */
/* return           fsgjt_return_code_t     (enum)                            */
/*                                                                            */
/**************************************|***************************************/
/*                                                                            */
/* Revision Log                                                               */
/*      Date             Who                                                  */
/*      2007.08.07       Glen W. Petrie                                       */
/*    # Original code                                                         */
/*                                                                            */
/**************************************|***************************************/
fsgjt_return_code_t fsgjtGetNextValue(  /* OP_INT32  */

        fsgjt_attribute_t   attribute,  /* void*     */
        void**              nextValue,  /* void**    */
        fsgjt_present_t*    moreValues  /* enum*     */

) {
/*** Declaration of Local Routine Variables                                   */
fsgjt_return_code_t  status;

/*** API Identifier Information for this Routine                              */
	OP_API_REG(150802, "fsgjtGetNextValue");

/*** Debug Flow Information for this Routine                                  */
    opDebugFlowIn("fsgjtGetNextValue");

/*** Initialization of Local Routine Variables                                */
    status = FSGJT_OK;

/*** Return to Caller                                                         */
    FSG_SET_ERR(status);
    opDebugFlowOut("fsgjtGetNextValue");
    return(status);

}


/**************************************|***************************************/
/*                                                              API-150803    */
/* fsgjtGetNumValues - Get the number of values that the Attribute contains.  */
/*                                                                            */
/* param (input)    fsgjt_attribute_t   attribute                             */
/*                  - Attribute whose number of values to get                 */
/*                                                                            */
/* param (output)   fsgjt_int32_t*      numValues                             */
/*                  - Number of values                                        */
/*                                                                            */
/* return           fsgjt_return_code_t     (enum)                            */
/*                                                                            */
/**************************************|***************************************/
/*                                                                            */
/* Revision Log                                                               */
/*      Date             Who                                                  */
/*      2007.08.07       Glen W. Petrie                                       */
/*    # Original code                                                         */
/*                                                                            */
/**************************************|***************************************/
fsgjt_return_code_t fsgjtGetNumValues(  /* OP_INT32  */

        fsgjt_attribute_t   attribute,  /* void*     */
        fsgjt_int32_t*      numValues   /* OP_INT32* */

) {
/*** Declaration of Local Routine Variables                                   */
fsgjt_return_code_t  status;

/*** API Identifier Information for this Routine                              */
	OP_API_REG(150803, "fsgjtGetNumValues");

/*** Debug Flow Information for this Routine                                  */
    opDebugFlowIn("fsgjtGetNumValues");

/*** Initialization of Local Routine Variables                                */
    status = FSGJT_OK;

/*** Return to Caller                                                         */
    FSG_SET_ERR(status);
    opDebugFlowOut("fsgjtGetNumValues");
    return(status);

}

/**************************************|***************************************/
/*                                                              API-150804    */
/* fsgjtGetValueType - Returns the type of the Attribute's values.            */
/*                                                                            */
/* param (input)    fsgjt_attribute_t   attribute                             */
/*                  - Attribute whose value type to get                       */
/*                                                                            */
/* param (output)   fsgjt_text_t*       type                                  */
/*                  - Type of this Attribute's values (use Value Types)       */
/*                                                                            */
/* return           fsgjt_return_code_t     (enum)                            */
/*                                                                            */
/**************************************|***************************************/
/*                                                                            */
/* Revision Log                                                               */
/*      Date             Who                                                  */
/*      2007.08.07       Glen W. Petrie                                       */
/*    # Original code                                                         */
/*                                                                            */
/**************************************|***************************************/
fsgjt_return_code_t fsgjtGetValueType(  /* OP_INT32  */

        fsgjt_attribute_t   attribute,  /* void*     */
        fsgjt_text_t*       type        /* char**    */

) {
/*** Declaration of Local Routine Variables                                   */
fsgjt_return_code_t  status;

/*** API Identifier Information for this Routine                              */
	OP_API_REG(150804, "fsgjtGetValueType");

/*** Debug Flow Information for this Routine                                  */
    opDebugFlowIn("fsgjtGetValueType");

/*** Initialization of Local Routine Variables                                */
    status = FSGJT_OK;

/*** Return to Caller                                                         */
    FSG_SET_ERR(status);
    opDebugFlowOut("fsgjtGetValueType");
    return(status);

}

/**************************************|***************************************/
/*                                                              API-150805    */
/* fsgjtResetToFirstValue - Reset the iterator to point to the first value of */
/*                          the Attribute.                                    */
/*                                                                            */
/* param (input)    fsgjt_attribute_t   attribute                             */
/*                  - Attribute to reset                                      */
/*                                                                            */
/* return           fsgjt_return_code_t     (enum)                            */
/*                                                                            */
/**************************************|***************************************/
/*                                                                            */
/* Revision Log                                                               */
/*      Date             Who                                                  */
/*      2007.08.07       Glen W. Petrie                                       */
/*    # Original code                                                         */
/*                                                                            */
/**************************************|***************************************/
fsgjt_return_code_t fsgjtResetToFirstValue(  /* OP_INT32  */

        fsgjt_attribute_t   attribute        /* void*     */

) {
/*** Declaration of Local Routine Variables                                   */
fsgjt_return_code_t  status;

/*** API Identifier Information for this Routine                              */
	OP_API_REG(150805, "fsgjtResetToFirstValue");

/*** Debug Flow Information for this Routine                                  */
    opDebugFlowIn("fsgjtResetToFirstValue");

/*** Initialization of Local Routine Variables                                */
    status = FSGJT_OK;

/*** Return to Caller                                                         */
    FSG_SET_ERR(status);
    opDebugFlowOut("fsgjtResetToFirstValue");
    return(status);

}

/*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%|%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%*/
/*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%|%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%*/
/*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%|%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%*/
/*       Destroy    Destroy    Destroy    Destroy    Destroy    Destroy       */
/*     Attributes Attributes Attributes Attributes Attributes Attributes      */
/*       /Values    /Values    /Values    /Values    /Values    /Values       */
/* -------------------------------------------------------------------------- */
/* -------------------------------------------------------------------------- */
/*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%|%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%*/
/*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%|%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%*/
/*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%|%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%*/


/**************************************|***************************************/
/*                                                              API-150850    */
/* fsgjtDestroyAttribute - Free the memory used by the Attribute.             */
/*                                                                            */
/* param (input)    fsgjt_attribute_t   attribute                             */
/*                  - Attribute to free                                       */
/*                                                                            */
/* return           fsgjt_return_code_t     (enum)                            */
/*                                                                            */
/**************************************|***************************************/
/*                                                                            */
/* Revision Log                                                               */
/*      Date             Who                                                  */
/*      2007.08.07       Glen W. Petrie                                       */
/*    # Original code                                                         */
/*                                                                            */
/**************************************|***************************************/
fsgjt_return_code_t fsgjtDestroyAttribute(  /* OP_INT32  */

        fsgjt_attribute_t   attribute       /* void*     */

) {
/*** Declaration of Local Routine Variables                                   */
fsgjt_return_code_t  status;

/*** API Identifier Information for this Routine                              */
	OP_API_REG(150850, "fsgjtDestroyAttribute");

/*** Debug Flow Information for this Routine                                  */
    opDebugFlowIn("fsgjtDestroyAttribute");

/*** Initialization of Local Routine Variables                                */
    status = FSGJT_OK;

/*** Return to Caller                                                         */
    FSG_SET_ERR(status);
    opDebugFlowOut("fsgjtDestroyAttribute");
    return(status);

}

/*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%|%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%*/
/*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%|%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%*/
/*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%|%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%*/
/*%%%%%%%%%%%%%%%%%%%%                                   %%%%%%%%%%%%%%%%%%%%%*/
/*--------------------         Internal Functions        ---------------------*/
/*%%%%%%%%%%%%%%%%%%%%                                   %%%%%%%%%%%%%%%%%%%%%*/
/*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%|%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%*/
/*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%|%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%*/
/*%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%|%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%*/

/**************************************|***************************************/
/*                                                                            */
/* CreateJtElement - Create a new Job Ticket Element Record.                  */
/*                                                                            */
/* return           fsgjt_element_t*    Pointer to new element record         */
/*                                                                            */
/**************************************|***************************************/
/*                                                                            */
/* Revision Log                                                               */
/*      Date             Who                                                  */
/*      2007.08.07       Glen W. Petrie                                       */
/*    # Original code                                                         */
/*                                                                            */
/**************************************|***************************************/
static fsgjt_element_t* CreateJtElement(

        void

) {
/*** Declaration of Local Routine Variables                                   */
fsgjt_element_t*    newPtr;
fsgjt_element_t**   newLst;

/*** Debug Flow Information for this Routine                                  */
    opDebugFlowIn("Internal: CreateJtElement");

/*** Initialization of Local Routine Variables                                */

/*** Allocated a new Element record                                           */
    newPtr = (fsgjt_element_t*)malloc(sizeof(fsgjt_element_t));
    while (newPtr != NULL) {
        numJtElements++;
        newLst = (fsgjt_element_t**)realloc
                        (jtElements,numJtElements*sizeof(fsgjt_element_t*));
        if (newLst == NULL) { free(newPtr); numJtElements--; break; }
        jtElements = newLst;
        jtElements[numJtElements] = newPtr;
    }

/*** Return to Caller                                                         */
    opDebugFlowOut("Internal: CreateJtElement");
    return((fsgjt_element_t*)newPtr);

}

/**************************************|***************************************/
/*                                                                            */
/* DestroyJtElement - Destroy a Job Ticket Element Record.                    */
/*                                                                            */
/* param (input)    fsgjt_element_t*    thisElement                           */
/*                  - Job Ticket element to destroy                           */
/*                                                                            */
/* return           void                                                      */
/*                                                                            */
/**************************************|***************************************/
/*                                                                            */
/* Revision Log                                                               */
/*      Date             Who                                                  */
/*      2007.08.07       Glen W. Petrie                                       */
/*    # Original code                                                         */
/*                                                                            */
/**************************************|***************************************/
static void DestroyJtElement(

        fsgjt_element_t*    thisElement

) {
/*** Declaration of Local Routine Variables                                   */

/*** Debug Flow Information for this Routine                                  */
    opDebugFlowIn("Internal: DestroyJtElement");

/*** Initialization of Local Routine Variables                                */

/*** Allocated a new Element record                                           */

/*** Return to Caller                                                         */
    opDebugFlowOut("Internal: DestroyJtElement");
    return;

}

/*_____________________________   fsgJTAPI.c   _______________________________*/

/*3456789012345678901234567890123456789012345678901234567890123456789012345678*/
/*       1         2         3         4         5         6         7        */
/**************************************|***************************************/
/*** End of File ** End of File ** End of File ** End of File ** End of File  */
/**************************************|***************************************/
